(function() {
	if (undefined == window['J2C']) {
		window['J2C'] = {}
	}

	function uuid_kit() {
		var s = [];
		var hexDigits = "0123456789abcdef";
		for (var i = 0; i < 36; i++) {
			s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
		}
		s[14] = "4";
		s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);
		s[8] = s[13] = s[18] = s[23] = "-";
		var uuid = s.join("");
		return uuid;
	}
	var callArray_kit = [];
	getToken4NanNingBack = function(tokenObject) {
		window.localStorage.setItem("token", tokenObject)
	};

	function requestGetToken4Nanning(callback) {
		getToken4NanNingBack = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestGetToken4Nanning.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestGetToken4Nanning', {
				'param': "      "
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestGetToken4Nanning', {
				'param': "      "
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getUserInfowechat();
		} else if (window.AlipayJSBridge) {
			getUserInfowechat();
		} else {
			getUserInfowechat();
		}
	}

	function onGetTokenSuccessed4NanNing(tokenObject) {
		getToken4NanNingBack(tokenObject);
	}
	isLoginback = function(statusObject) {};

	function requestISLogin(callback) {
		isLoginback = callback;
		if (window.iosdkqgqc) {
			window.webkit.requestISLogin();
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestISLogin', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestISLogin', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function requestISLoginSuccessed(statusObject) {
		isLoginback(statusObject);
	}
	isPensionCertificationback = function(statusObject) {};

	function requestPensionCertification(idNumber, name, callback) {
		isPensionCertificationback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestPensionCertification.postMessage({
				'idNumber': idNumber,
				'name': name
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestPensionCertification', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestPensionCertification', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function requestPensionCertificationSuccessed(statusObject) {
		isPensionCertificationback(statusObject);
	}
	isInjuryCertificationback = function(statusObject) {};

	function requestInjuryCertification(idNumber, name, callback) {
		isInjuryCertificationback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestInjuryCertification.postMessage({
				'idNumber': idNumber,
				'name': name
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestInjuryCertification', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestInjuryCertification', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function requestInjuryCertificationSuccessed(statusObject) {
		isInjuryCertificationback(statusObject);
	}
	var survivalback = function(statusObject) {};

	function requestSurvival(idNumber, name, callback) {
		survivalback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestSurvival.postMessage({
				'idNumber': idNumber,
				'name': name
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestSurvival', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestSurvival', {
				'idNumber': idNumber,
				'name': name
			}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onrequestSurvivalSuccessed(statusObject) {
		survivalback(statusObject);
	}

	function viewPdf(paramJsonObj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.viewPdf.postMessage({
				'body': paramJsonObj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.viewPdf', paramJsonObj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.viewPdf', paramJsonObj, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getViewPdf(paramJsonObj, "WECHAT");
		} else if (window.AlipayJSBridge) {
			getViewPdf(paramJsonObj, "ALIPAY");
		} else {
			getViewPdf(paramJsonObj, "PC");
		}
	}
	var scanFaceCallback = new function(obj) {};

	function scanFace(obj, invokeCallback) {
		if (invokeCallback != null)
			scanFaceCallback = invokeCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.scanFace.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.scanFace', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.scanFace', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onScanFaceSuccessed(callbackparam) {
		scanFaceCallback(callbackparam);
	};
	var startQRCodeCallback = new function(obj) {};

	function startQRCode(obj, callback) {
		startQRCodeCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startQRCode.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startQRCode', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startQRCode', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onstartQRCodeSuccessed(obj) {
		startQRCodeCallback(obj);
	}
	var startXunfeiYuYinCallback = function(obj) {};

	function startXunfeiYuYin(obj, callback) {
		if (callback != null)
			startXunfeiYuYinCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startXunfeiYuYin.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startXunfeiYuYin', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startXunfeiYuYin', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onstartXunfeiYuYined(obj) {
		startXunfeiYuYinCallback(obj);
	}
	var endXunfeiYuYinCallback = function(obj) {};

	function endXunfeiYuYin(callback) {
		endXunfeiYuYinCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.endXunfeiYuYin.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.endXunfeiYuYin', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.endXunfeiYuYin', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onendXunfeiYuYined(obj) {
		endXunfeiYuYinCallback(obj);
	}
	var cancelXunfeiYuYinCallback = function(obj) {};

	function cancelXunfeiYuYin(callback) {
		cancelXunfeiYuYinCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.cancelXunfeiYuYin.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.cancelXunfeiYuYin', {}, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.cancelXunfeiYuYin', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function oncancelXunfeiYuYined(obj) {
		cancelXunfeiYuYinCallback(obj);
	}
	var startBaiduYuYinCallback = function(obj) {};

	function startBaiduYuYin(obj, callback) {
		if (callback != null)
			startBaiduYuYinCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startBaiduYuYin.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startBaiduYuYin', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startBaiduYuYin', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onstartBaiduYuYined(obj) {
		startBaiduYuYinCallback(obj);
	}

	function endBaiduYuYin() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.endBaiduYuYin.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.endBaiduYuYin', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.endBaiduYuYin', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function getLogInHistory(callback) {
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getLogInHistory.postMessage({
				'serialNum': serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getLogInHistory', {
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getLogInHistory', {
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getLogInHistoryPWA(serialNum);
		} else if (window.AlipayJSBridge) {
			getLogInHistoryPWA(serialNum);
		} else {
			getLogInHistoryPWA(serialNum);
		}
	}

	function onGetLogInHistory(par) {
		var serialNum = par.serialNum;
		var obj = par.obj;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(obj);
				}
				return;
			}
		}
	}

	function getLogInAccountId(callback) {
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getLogInAccountId.postMessage({
				'serialNum': serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getLogInAccountId', {
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getLogInAccountId', {
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getLogInAccountIdPWA(serialNum);
		} else if (window.AlipayJSBridge) {
			getLogInAccountIdPWA(serialNum);
		} else {
			getLogInAccountIdPWA(serialNum);
		}
	}

	function ongetLogInAccountId(par) {
		var accountId = par.accountId;
		var serialNum = par.serialNum;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(accountId);
				}
				return;
			}
		}
	}

	function chooseAccount(accountId) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.chooseAccount.postMessage({
				'accountId': accountId
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.chooseAccount', {
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.chooseAccount', {
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			chooseAccountPWA(accountId);
		} else if (window.AlipayJSBridge) {
			chooseAccountPWA(accountId);
		} else {
			chooseAccountPWA(accountId);
		}
	}

	function logInOut() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.logInOut.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.logInOut', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.logInOut', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			logInOutPWA();
		} else if (window.AlipayJSBridge) {
			logInOutPWA();
		} else {
			logInOutPWA();
		}
	}

	function saveAccountInfo(accountId, token, refreshToken, userName) {
		if (!accountId || !token || !refreshToken || !userName) {
			throw new Error('saveAccountInfo                   ');
		}
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveAccountInfo.postMessage({
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveAccountInfo', {
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveAccountInfo', {
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
		} else if (window.AlipayJSBridge) {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
		} else {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
		}
	}

	function saveAccountInfoWithCallback(accountId, token, refreshToken, userName, callback) {
		if (!accountId || !token || !refreshToken || !userName) {
			throw new Error('saveAccountInfoWithCallback                   ');
		}
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveAccountInfoWithCallback.postMessage({
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName,
				"serialNum": serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveAccountInfoWithCallback', {
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName,
				"serialNum": serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveAccountInfoWithCallback', {
				'accountId': accountId,
				'token': token,
				'refreshToken': refreshToken,
				'userName': userName,
				"serialNum": serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
			callback(JSON.stringify({
				'error': ''
			}));
		} else if (window.AlipayJSBridge) {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
			callback(JSON.stringify({
				'error': ''
			}));
		} else {
			saveAccountInfoPWA(accountId, token, refreshToken, userName);
			callback(JSON.stringify({
				'error': ''
			}));
		}
	}

	function onsaveAccountInfoWithCallback(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function saveUserInfo(accountId, key, val) {
		if (!accountId || !key || !val) {
			throw new Error('saveAccountInfo                   ');
		}
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveUserInfo.postMessage({
				'accountId': accountId,
				'key': key,
				'val': val
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveUserInfo', {
				'accountId': accountId,
				'key': key,
				'val': val
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveUserInfo', {
				'accountId': accountId,
				'key': key,
				'val': val
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			saveUserInfoPWA(accountId, key, val);
		} else if (window.AlipayJSBridge) {
			saveUserInfoPWA(accountId, key, val);
		} else {
			saveUserInfoPWA(accountId, key, val);
		}
	}

	function saveUserInfoWithCallback(accountId, key, val, callback) {
		if (!accountId || !key || !val) {
			throw new Error('saveUserInfoWithCallback                   ');
		}
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveUserInfoWithCallback.postMessage({
				'accountId': accountId,
				'key': key,
				'val': val,
				'serialNum': serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveUserInfoWithCallback', {
				'accountId': accountId,
				'key': key,
				'val': val,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveUserInfoWithCallback', {
				'accountId': accountId,
				'key': key,
				'val': val,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			saveUserInfoPWA(accountId, key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		} else if (window.AlipayJSBridge) {
			saveUserInfoPWA(accountId, key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		} else {
			saveUserInfoPWA(accountId, key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		}
	}

	function onsaveUserInfoWithCallback(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function getAccountInfo(accountId, callback) {
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getAccountInfo.postMessage({
				'serialNum': serialNum,
				'accountId': accountId
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getAccountInfo', {
				'serialNum': serialNum,
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getAccountInfo', {
				'serialNum': serialNum,
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getAccountInfoPWA(accountId, serialNum);
		} else if (window.AlipayJSBridge) {
			getAccountInfoPWA(accountId, serialNum);
		} else {
			getAccountInfoPWA(accountId, serialNum);
		}
	}

	function onGetAccountInfo(par) {
		var accountId = par.accountId;
		var serialNum = par.serialNum;
		var token = par.token;
		var refreshToken = par.refreshToken;
		var userName = par.userName;
		var obj = {
			"accountId": accountId,
			"token": token,
			"refreshToken": refreshToken,
			"userName": userName
		}
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(obj);
				}
				return;
			}
		}
	}

	function getUserInfo(accountId, key, callback) {
		var serialNum = uuid_kit();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray_kit.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getUserInfo.postMessage({
				'key': key,
				'serialNum': serialNum,
				'accountId': accountId
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getUserInfo', {
				'key': key,
				'serialNum': serialNum,
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getUserInfo', {
				'key': key,
				'serialNum': serialNum,
				'accountId': accountId
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			getUserInfoPWA(accountId, key, serialNum);
		} else if (window.AlipayJSBridge) {
			getUserInfoPWA(accountId, key, serialNum);
		} else {
			getUserInfoPWA(accountId, key, serialNum);
		}
	}

	function ongetUserInfo(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function openLiveness(obj, callbackOnShow, callbackOnComplete) {
		var serialNumOnShow = uuid_kit();
		var serialNumOnComplete = uuid_kit();
		var callOnShow = {};
		callOnShow.serialNum = serialNumOnShow;
		callOnShow.callback = callbackOnShow;
		callArray_kit.push(callOnShow);
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnShow = serialNumOnShow;
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openLiveness.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openLiveness', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openLiveness', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onShowOpenLiveness(par) {
		var serialNum = par.serialNum;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback();
				}
				return;
			}
		}
	}

	function onCompleteOpenLiveness(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function openOcr(obj, callbackOnShow, callbackOnComplete) {
		var serialNumOnShow = uuid_kit();
		var serialNumOnComplete = uuid_kit();
		var callOnShow = {};
		callOnShow.serialNum = serialNumOnShow;
		callOnShow.callback = callbackOnShow;
		callArray_kit.push(callOnShow);
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnShow = serialNumOnShow;
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openOcr.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openOcr', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openOcr', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onShowOpenOcr(par) {
		var serialNum = par.serialNum;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback();
				}
				return;
			}
		}
	}

	function onCompleteOpenOcr(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function loginNeteaseim(obj, callbackOnComplete) {
		var serialNumOnComplete = uuid_kit();
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.loginNeteaseim.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.loginNeteaseim', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.loginNeteaseim', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onCompleteLoginNeteaseim(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function videoCallNeteaseim(towho, extendMessage) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.videoCallNeteaseim.postMessage({
				'towho': towho,
				'extendMessage': extendMessage
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.videoCallNeteaseim', {
				'towho': towho,
				'extendMessage': extendMessage
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.videoCallNeteaseim', {
				'towho': towho,
				'extendMessage': extendMessage
			}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function startIbeaconbc(obj, callbackOnComplete) {
		var serialNumOnComplete = uuid_kit();
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startIbeaconbc.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startIbeaconbc', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startIbeaconbc', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onCompleteStartIbeaconbc(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function stopIbeaconbc() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.stopIbeaconbc.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.stopIbeaconbc', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.stopIbeaconbc', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}
	var startMonitoringCallback = new function(obj) {};

	function startMonitoring(uuids, callbackOnComplete) {
		startMonitoringCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startMonitoring.postMessage({
				'uuids': uuids
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startMonitoring', {
				"uuids": uuids
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startMonitoring', {
				"uuids": uuids
			}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onstartMonitoringResult(obj) {
		startMonitoringCallback(obj);
	}

	function stopMonitoring() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.stopMonitoring.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.stopMonitoring', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.stopMonitoring', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}
	var updateMonitoringCallback = new function(obj) {};

	function updateMonitoring(callbackOnComplete) {
		updateMonitoringCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.updateMonitoring.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.updateMonitoring', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.updateMonitoring', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onupdateMonitoringResult(obj) {
		updateMonitoringCallback(obj);
	}
	var esscOnResultCallback = new function(obj) {};
	var esscOnSceneResultCallback = new function(obj) {};

	function openEssc(obj, callbackOnResult, callbackOnSceneResult) {
		esscOnResultCallback = callbackOnResult;
		esscOnSceneResultCallback = callbackOnSceneResult;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openEssc.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openEssc', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openEssc', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function closeEssc() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.closeEssc.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.closeEssc', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.closeEssc', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onEsscResult(obj) {
		esscOnResultCallback(obj);
	}

	function onEsscSceneResult(obj) {
		esscOnSceneResultCallback(obj);
	}
	var signSROnResultCallback = new function(obj) {};

	function openSignSR(callbackOnResult) {
		signSROnResultCallback = callbackOnResult;
		if (window.iosdkqgqc) {
			alert("iOS do not allow to do this!");
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openSignSR', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openSignSR', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onSignSRResult(obj) {
		signSROnResultCallback(obj);
	}
	var openLivenessBdSyncCompeleteCallback = new function(val) {};
	var openLivenessBdAsynCompeleteCallback = new function(val) {};
	var openLivenessBdDetectCompeleteCallback = new function(val) {};

	function openLivenessBdSync(obj, callbackOnComplete) {
		openLivenessBdSyncCompeleteCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openLivenessBdSync.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openLivenessBdSync', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openLivenessBdSync', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function openLivenessBdAsyn(obj, callbackOnComplete) {
		openLivenessBdAsynCompeleteCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openLivenessBdAsyn.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openLivenessBdAsyn', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openLivenessBdAsyn', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function openLivenessBdDetect(obj, callbackOnComplete) {
		openLivenessBdDetectCompeleteCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openLivenessBdDetect.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openLivenessBdDetect', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openLivenessBdDetect', obj, function(
				responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onCompleteOpenLivenessBdSync(val) {
		openLivenessBdSyncCompeleteCallback(val);
	}

	function onCompleteOpenLivenessBdAsyn(val) {
		openLivenessBdAsynCompeleteCallback(val);
	}

	function onCompleteOpenLivenessBdDetect(val) {
		openLivenessBdDetectCompeleteCallback(val);
	}
	var openLivenessBdEnhanceCompeleteCallback = new function(val) {};

	function openLivenessBdEnhance(obj, callbackOnComplete) {
		openLivenessBdEnhanceCompeleteCallback = callbackOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openLivenessBdEnhance.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openLivenessBdEnhance', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openLivenessBdEnhance', obj, function(
				responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onCompleteOpenLivenessBdEnhance(val) {
		openLivenessBdEnhanceCompeleteCallback(val);
	}
	var requestAlipayCallback = new function(res) {};

	function requestAlipay(obj, callback) {
		requestAlipayCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestAlipay.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestAlipay', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestAlipay', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestAlipayCallbackSuccessed(res) {
		requestAlipayCallback(res);
	}
	var requestLngAndLatCallback = new function(res) {};

	function requestLngAndLat(callback) {
		requestLngAndLatCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestLngAndLat.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestLngAndLat', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestLngAndLat', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestLngAndLatCallbackSuccessed(res) {
		requestLngAndLatCallback(res);
	}
	var openPolyvPlayerCallback = new function(obj) {};
	var openPolyvPlayerFinishCallback = new function() {};

	function openPolyvPlayer(obj, callback, finishCallback) {
		openPolyvPlayerCallback = callback;
		openPolyvPlayerFinishCallback = finishCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openPolyvPlayer.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openPolyvPlayer', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openPolyvPlayer', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onPolyvPlayerReported(obj) {
		openPolyvPlayerCallback(obj);
	}

	function onPolyvPlayerFinished() {
		openPolyvPlayerFinishCallback();
	}
	var requestWxShareCallBack = function(val) {};

	function requestWxShare(obj, callBack) {
		requestWxShareCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestWxShare.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestWxShare', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestWxShare', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onRequestWxShareCallBack(val) {
		requestWxShareCallBack(val);
	}
	var shotVideoCallback = new function(val) {};
	var shotVideoShowCallback = new function(val) {};

	function openShotVideo(obj, showCallBack, callBack) {
		shotVideoShowCallback = showCallBack;
		shotVideoCallback = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openShotVideo.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openShotVideo', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openShotVideo', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onShotVideoCallback(val) {
		shotVideoCallback(val);
	}

	function onShotVideoShowCallback(val) {
		shotVideoShowCallback(val);
	}
	var showPdfWithVidCallBack = function(val) {};

	function showPdfWithVid(paramJsonObj, callback) {
		showPdfWithVidCallBack = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.showPdfWithVid.postMessage(paramJsonObj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.showPdfWithVid', paramJsonObj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.showPdfWithVid', paramJsonObj, function(
			responseData) {});
		} else {}
	}

	function onShowPdfWithVidCallBack(val) {
		showPdfWithVidCallBack(val);
	}
	var startSbcYuYinCallback = function(obj) {};

	function startSbcYuYin(obj, callback) {
		if (callback != null)
			startSbcYuYinCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.startSbcYuYin.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.startSbcYuYin', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.startSbcYuYin', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onstartSbcYuYined(obj) {
		startSbcYuYinCallback(obj);
	}

	function endSbcYuYin() {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.endSbcYuYin.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.endSbcYuYin', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.endSbcYuYin', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}
	var requestZhiHuiYanCallBack = function(val) {};

	function onRequestZhiHuiYanCallBack(val) {
		requestZhiHuiYanCallBack(val);
	}

	function requestZhiHuiYan(obj, callBack) {
		requestZhiHuiYanCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestZhiHuiYan.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestZhiHuiYan', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestZhiHuiYan', {}, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}
	var isAppInstalledCallback = new function(res) {};

	function isAppInstalled(obj, callback) {
		isAppInstalledCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.isAppInstalled.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.isAppInstalled', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.isAppInstalled', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onIsAppInstalledCallback(res) {
		isAppInstalledCallback(res);
	}
	var requestWxLaunchMiniProgramCallBack = function(val) {};

	function requestWxLaunchMiniProgram(obj, callBack) {
		requestWxLaunchMiniProgramCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestWxLaunchMiniProgram.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestWxLaunchMiniProgram', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestWxLaunchMiniProgram', obj, function(
				responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onRequestWxLaunchMiniProgramCallBack(val) {
		requestWxLaunchMiniProgramCallBack(val);
	}
	var requestAlipayVerifyCallback = function(obj) {};

	function requestAlipayVerify(obj, invokeCallback) {
		if (invokeCallback != null)
			requestAlipayVerifyCallback = invokeCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestAlipayVerify.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestAlipayVerify', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestAlipayVerify', obj, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestAlipayVerifySuccessed(callbackparam) {
		requestAlipayVerifyCallback(callbackparam);
	};

	function ecpayOpenSettleList(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.ecpayOpenSettleList.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.ecpayOpenSettleList', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.ecpayOpenSettleList', obj, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function ecpayOpenSettleRecord(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.ecpayOpenSettleRecord.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.ecpayOpenSettleRecord', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.ecpayOpenSettleRecord', obj, function(
				responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function ecpayOpenBankManager(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.ecpayOpenBankManager.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.ecpayOpenBankManager', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.ecpayOpenBankManager', obj, function(
				responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}
	var requestWxpayCallback = new function(res) {};

	function requestWxpay(obj, callback) {
		requestWxpayCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestWxpay.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestWxpay', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestWxpay', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestWxpayCallbackSuccessed(res) {
		requestWxpayCallback(res);
	}

	function openBdOcr(obj, callbackOnShow, callbackOnComplete) {
		var serialNumOnShow = uuid_kit();
		var serialNumOnComplete = uuid_kit();
		var callOnShow = {};
		callOnShow.serialNum = serialNumOnShow;
		callOnShow.callback = callbackOnShow;
		callArray_kit.push(callOnShow);
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnShow = serialNumOnShow;
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openBdOcr.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openBdOcr', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openBdOcr', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onShowOpenBdOcr(par) {
		var serialNum = par.serialNum;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback();
				}
				return;
			}
		}
	}

	function onCompleteOpenBdOcr(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function openBdOcrNoQc(obj, callbackOnShow, callbackOnComplete) {
		var serialNumOnShow = uuid_kit();
		var serialNumOnComplete = uuid_kit();
		var callOnShow = {};
		callOnShow.serialNum = serialNumOnShow;
		callOnShow.callback = callbackOnShow;
		callArray_kit.push(callOnShow);
		var callOnComplete = {};
		callOnComplete.serialNum = serialNumOnComplete;
		callOnComplete.callback = callbackOnComplete;
		callArray_kit.push(callOnComplete);
		obj.serialNumOnShow = serialNumOnShow;
		obj.serialNumOnComplete = serialNumOnComplete;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openBdOcrNoQc.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openBdOcrNoQc', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openBdOcrNoQc', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onShowOpenBdOcrNoQc(par) {
		var serialNum = par.serialNum;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback();
				}
				return;
			}
		}
	}

	function onCompleteOpenBdOcrNoQc(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray_kit) {
			var s = callArray_kit[x].serialNum;
			var callback = callArray_kit[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}
	var getProtectInfoCallback = new function(res) {};

	function getProtectInfo(callback) {
		getProtectInfoCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getProtectInfo.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getProtectInfo', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getProtectInfo', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onGetProtectInfoCallbackSuccessed(res) {
		getProtectInfoCallback(res);
	}
	var requestAlipayVerifyV2Callback = new function(obj) {};
	var requestAlipayVerifyV2Callback2 = new function() {};

	function requestAlipayVerifyV2(obj, invokeCallback, invokeCallback2) {
		if (invokeCallback != null) {
			requestAlipayVerifyV2Callback = invokeCallback;
		}
		if (invokeCallback2 != null) {
			requestAlipayVerifyV2Callback2 = invokeCallback2;
		}
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestAlipayVerifyV2.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestAlipayVerifyV2', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestAlipayVerifyV2', obj, function(
				responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestAlipayVerifyV2Successed(callbackparam) {
		requestAlipayVerifyV2Callback(callbackparam);
	};

	function requestAlipayVerifyV2Successed2() {
		requestAlipayVerifyV2Callback2();
	};
	var getBizCodeAlipayVerifyV2Callback = new function(obj) {};

	function getBizCodeAlipayVerifyV2(invokeCallback) {
		if (invokeCallback != null)
			getBizCodeAlipayVerifyV2Callback = invokeCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getBizCodeAlipayVerifyV2.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getBizCodeAlipayVerifyV2', {}, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getBizCodeAlipayVerifyV2', {}, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function getBizCodeAlipayVerifyV2Successed(callbackparam) {
		getBizCodeAlipayVerifyV2Callback(callbackparam);
	};
	var requestOnecodeAuthCallback = new function(obj) {};

	function requestOnecodeAuth(obj, callback) {
		requestOnecodeAuthCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestOnecodeAuth.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestOnecodeAuth', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestOnecodeAuth', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function requestOnecodeAuthSuccessed(obj) {
		requestOnecodeAuthCallback(obj);
	}
	var cameraToBase64CallBack = function(obj) {};

	function cameraToBase64(obj, callBack) {
		cameraToBase64CallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.cameraToBase64.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.cameraToBase64', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.cameraToBase64', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function onCameraToBase64CallBack(obj) {
		cameraToBase64CallBack(obj);
	}
	var gesturelockSetupCallBack = function(obj) {};

	function gesturelockSetup(obj, callBack) {
		gesturelockSetupCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.gesturelockSetup.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.gesturelockSetup', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.gesturelockSetup', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function gesturelockSetupSuccessed(obj) {
		gesturelockSetupCallBack(obj);
	}
	var gesturelockVerifyCallBack = function(obj) {};

	function gesturelockVerify(obj, callBack) {
		gesturelockVerifyCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.gesturelockVerify.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.gesturelockVerify', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.gesturelockVerify', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function gesturelockVerifySuccessed(obj) {
		gesturelockVerifyCallBack(obj);
	}
	var gesturelockExistCallBack = function(obj) {};

	function gesturelockExist(obj, callBack) {
		gesturelockExistCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.gesturelockExist.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.gesturelockExist', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.gesturelockExist', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function gesturelockExistSuccessed(obj) {
		gesturelockExistCallBack(obj);
	}
	var gesturelockRemoveCallBack = function(obj) {};

	function gesturelockRemove(obj, callBack) {
		gesturelockRemoveCallBack = callBack;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.gesturelockRemove.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.gesturelockRemove', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.gesturelockRemove', obj, function(responseData) {});
		} else {
			throw new Error('J2C env init error');
		}
	}

	function gesturelockRemoveSuccessed(obj) {
		gesturelockRemoveCallBack(obj);
	}
	window['J2C']['requestGetToken4NanNing'] = requestGetToken4Nanning;
	window['J2C']['onGetTokenSuccessed4NanNing'] = onGetTokenSuccessed4NanNing;
	window['J2C']['requestISLogin'] = requestISLogin;
	window['J2C']['requestISLoginSuccessed'] = requestISLoginSuccessed;
	window['J2C']['requestPensionCertification'] = requestPensionCertification;
	window['J2C']['requestPensionCertificationSuccessed'] = requestPensionCertificationSuccessed;
	window['J2C']['requestInjuryCertification'] = requestInjuryCertification;
	window['J2C']['requestInjuryCertificationSuccessed'] = requestInjuryCertificationSuccessed;
	window['J2C']['requestSurvival'] = requestSurvival;
	window['J2C']['onrequestSurvivalSuccessed'] = onrequestSurvivalSuccessed;
	window['J2C']['viewPdf'] = viewPdf;
	window['J2C']['scanFace'] = scanFace;
	window['J2C']['onScanFaceSuccessed'] = onScanFaceSuccessed;
	window['J2C']['startQRCode'] = startQRCode;
	window['J2C']['onstartQRCodeSuccessed'] = onstartQRCodeSuccessed;
	window['J2C']['startXunfeiYuYin'] = startXunfeiYuYin;
	window['J2C']['onstartXunfeiYuYined'] = onstartXunfeiYuYined;
	window['J2C']['endXunfeiYuYin'] = endXunfeiYuYin;
	window['J2C']['onendXunfeiYuYined'] = onendXunfeiYuYined;
	window['J2C']['cancelXunfeiYuYin'] = cancelXunfeiYuYin;
	window['J2C']['oncancelXunfeiYuYined'] = oncancelXunfeiYuYined;
	window['J2C']['startBaiduYuYin'] = startBaiduYuYin;
	window['J2C']['onstartBaiduYuYined'] = onstartBaiduYuYined;
	window['J2C']['endBaiduYuYin'] = endBaiduYuYin;
	window['J2C']['getLogInHistory'] = getLogInHistory;
	window['J2C']['onGetLogInHistory'] = onGetLogInHistory;
	window['J2C']['getLogInAccountId'] = getLogInAccountId;
	window['J2C']['ongetLogInAccountId'] = ongetLogInAccountId;
	window['J2C']['chooseAccount'] = chooseAccount;
	window['J2C']['logInOut'] = logInOut;
	window['J2C']['saveAccountInfo'] = saveAccountInfo;
	window['J2C']['saveUserInfo'] = saveUserInfo;
	window['J2C']['getAccountInfo'] = getAccountInfo;
	window['J2C']['onGetAccountInfo'] = onGetAccountInfo;
	window['J2C']['getUserInfo'] = getUserInfo;
	window['J2C']['ongetUserInfo'] = ongetUserInfo;
	window['J2C']['openLiveness'] = openLiveness;
	window['J2C']['onShowOpenLiveness'] = onShowOpenLiveness;
	window['J2C']['onCompleteOpenLiveness'] = onCompleteOpenLiveness;
	window['J2C']['openOcr'] = openOcr;
	window['J2C']['onShowOpenOcr'] = onShowOpenOcr;
	window['J2C']['onCompleteOpenOcr'] = onCompleteOpenOcr;
	window['J2C']['loginNeteaseim'] = loginNeteaseim;
	window['J2C']['onCompleteLoginNeteaseim'] = onCompleteLoginNeteaseim;
	window['J2C']['videoCallNeteaseim'] = videoCallNeteaseim;
	window['J2C']['startIbeaconbc'] = startIbeaconbc;
	window['J2C']['onCompleteStartIbeaconbc'] = onCompleteStartIbeaconbc;
	window['J2C']['stopIbeaconbc'] = stopIbeaconbc;
	window['J2C']['startMonitoring'] = startMonitoring;
	window['J2C']['onstartMonitoringResult'] = onstartMonitoringResult;
	window['J2C']['stopMonitoring'] = stopMonitoring;
	window['J2C']['updateMonitoring'] = updateMonitoring;
	window['J2C']['onupdateMonitoringResult'] = onupdateMonitoringResult;
	window['J2C']['openEssc'] = openEssc;
	window['J2C']['closeEssc'] = closeEssc;
	window['J2C']['onEsscResult'] = onEsscResult;
	window['J2C']['onEsscSceneResult'] = onEsscSceneResult;
	window['J2C']['openSignSR'] = openSignSR;
	window['J2C']['onSignSRResult'] = onSignSRResult;
	window['J2C']['openLivenessBdSync'] = openLivenessBdSync;
	window['J2C']['onCompleteOpenLivenessBdSync'] = onCompleteOpenLivenessBdSync;
	window['J2C']['openLivenessBdAsyn'] = openLivenessBdAsyn;
	window['J2C']['onCompleteOpenLivenessBdAsyn'] = onCompleteOpenLivenessBdAsyn;
	window['J2C']['openLivenessBdDetect'] = openLivenessBdDetect;
	window['J2C']['onCompleteOpenLivenessBdDetect'] = onCompleteOpenLivenessBdDetect;
	window['J2C']['openLivenessBdEnhance'] = openLivenessBdEnhance;
	window['J2C']['onCompleteOpenLivenessBdEnhance'] = onCompleteOpenLivenessBdEnhance;
	window['J2C']['requestAlipay'] = requestAlipay;
	window['J2C']['requestAlipayCallbackSuccessed'] = requestAlipayCallbackSuccessed;
	window['J2C']['requestLngAndLat'] = requestLngAndLat;
	window['J2C']['requestLngAndLatCallbackSuccessed'] = requestLngAndLatCallbackSuccessed;
	window['J2C']['openPolyvPlayer'] = openPolyvPlayer;
	window['J2C']['onPolyvPlayerReported'] = onPolyvPlayerReported;
	window['J2C']['onPolyvPlayerFinished'] = onPolyvPlayerFinished;
	window['J2C']['requestWxShare'] = requestWxShare;
	window['J2C']['onRequestWxShareCallBack'] = onRequestWxShareCallBack;
	window['J2C']['openShotVideo'] = openShotVideo;
	window['J2C']['onShotVideoShowCallback'] = onShotVideoShowCallback;
	window['J2C']['onShotVideoCallback'] = onShotVideoCallback;
	window['J2C']['showPdfWithVid'] = showPdfWithVid;
	window['J2C']['onShowPdfWithVidCallBack'] = onShowPdfWithVidCallBack;
	window['J2C']['startSbcYuYin'] = startSbcYuYin;
	window['J2C']['endSbcYuYin'] = endSbcYuYin;
	window['J2C']['onstartSbcYuYined'] = onstartSbcYuYined;
	window['J2C']['requestZhiHuiYan'] = requestZhiHuiYan;
	window['J2C']['onRequestZhiHuiYanCallBack'] = onRequestZhiHuiYanCallBack;
	window['J2C']['isAppInstalled'] = isAppInstalled;
	window['J2C']['onIsAppInstalledCallback'] = onIsAppInstalledCallback;
	window['J2C']['saveAccountInfoWithCallback'] = saveAccountInfoWithCallback;
	window['J2C']['onsaveAccountInfoWithCallback'] = onsaveAccountInfoWithCallback;
	window['J2C']['saveUserInfoWithCallback'] = saveUserInfoWithCallback;
	window['J2C']['onsaveUserInfoWithCallback'] = onsaveUserInfoWithCallback;
	window['J2C']['requestWxLaunchMiniProgram'] = requestWxLaunchMiniProgram;
	window['J2C']['onRequestWxLaunchMiniProgramCallBack'] = onRequestWxLaunchMiniProgramCallBack;
	window['J2C']['requestAlipayVerify'] = requestAlipayVerify;
	window['J2C']['requestAlipayVerifySuccessed'] = requestAlipayVerifySuccessed;
	window['J2C']['ecpayOpenSettleList'] = ecpayOpenSettleList;
	window['J2C']['ecpayOpenSettleRecord'] = ecpayOpenSettleRecord;
	window['J2C']['ecpayOpenBankManager'] = ecpayOpenBankManager;
	window['J2C']['requestWxpay'] = requestWxpay;
	window['J2C']['requestWxpayCallbackSuccessed'] = requestWxpayCallbackSuccessed;
	window['J2C']['openBdOcr'] = openBdOcr;
	window['J2C']['onShowOpenBdOcr'] = onShowOpenBdOcr;
	window['J2C']['onCompleteOpenBdOcr'] = onCompleteOpenBdOcr;
	window['J2C']['openBdOcrNoQc'] = openBdOcrNoQc;
	window['J2C']['onShowOpenBdOcrNoQc'] = onShowOpenBdOcrNoQc;
	window['J2C']['onCompleteOpenBdOcrNoQc'] = onCompleteOpenBdOcrNoQc;
	window['J2C']['getProtectInfo'] = getProtectInfo;
	window['J2C']['onGetProtectInfoCallbackSuccessed'] = onGetProtectInfoCallbackSuccessed;
	window['J2C']['requestAlipayVerifyV2'] = requestAlipayVerifyV2;
	window['J2C']['requestAlipayVerifyV2Successed'] = requestAlipayVerifyV2Successed;
	window['J2C']['requestAlipayVerifyV2Successed2'] = requestAlipayVerifyV2Successed2;
	window['J2C']['getBizCodeAlipayVerifyV2'] = getBizCodeAlipayVerifyV2;
	window['J2C']['getBizCodeAlipayVerifyV2Successed'] = getBizCodeAlipayVerifyV2Successed;
	window['J2C']['requestOnecodeAuth'] = requestOnecodeAuth;
	window['J2C']['requestOnecodeAuthSuccessed'] = requestOnecodeAuthSuccessed;
	window['J2C']['cameraToBase64'] = cameraToBase64;
	window['J2C']['onCameraToBase64CallBack'] = onCameraToBase64CallBack;
	window['J2C']['gesturelockSetup'] = gesturelockSetup;
	window['J2C']['gesturelockSetupSuccessed'] = gesturelockSetupSuccessed;
	window['J2C']['gesturelockVerify'] = gesturelockVerify;
	window['J2C']['gesturelockVerifySuccessed'] = gesturelockVerifySuccessed;
	window['J2C']['gesturelockRemove'] = gesturelockRemove;
	window['J2C']['gesturelockRemoveSuccessed'] = gesturelockRemoveSuccessed;
	window['J2C']['gesturelockExist'] = gesturelockExist;
	window['J2C']['gesturelockExistSuccessed'] = gesturelockExistSuccessed;
})();
var J2C_CONFIG = {
	'pc': false
};
(function() {
	if (undefined == window['J2C']) {
		window['J2C'] = {}
	}
	var readyArray = [];
	j2cReadyCallback = function(event) {
		console.log("J2C                                                ");
		console.log("readyArray      " + readyArray.length);
		for (x in readyArray) {
			readyArray[x]();
		}
	};

	function registerJ2CReadyCallback(callback) {
		if (window.iosdkqgqc) {
			setTimeout(function() {
				callback('j2c_ready');
			}, 10);
		} else if (window.WebViewJ2CJavascriptBridge) {
			setTimeout(function() {
				callback('j2c_ready');
			}, 10);
		} else if (window.WebViewJavascriptBridge) {
			setTimeout(function() {
				callback('j2c_ready');
			}, 10);
		} else {
			if (J2C_CONFIG.pc) {
				setTimeout(function() {
					callback('j2c_ready');
				}, 10);
			} else {
				readyArray.push(callback);
				var j2cdoc = document;
				j2cdoc.addEventListener('WebViewJ2CJavascriptBridgeReady', j2cReadyCallback, false);
				j2cdoc.addEventListener('WebViewJavascriptBridgeReady', j2cReadyCallback, false);
				j2cdoc.addEventListener('WeixinJSBridgeReady', j2cReadyCallback, false);
				j2cdoc.addEventListener('AlipayJSBridgeReady', j2cReadyCallback, false);
			}
		}
	}

	function showNativeToast(toast) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.showToast.postMessage({
				'body': toast
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.showToast', {
				'param': toast
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.showToast', {
				'param': toast
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webshowNativeToast(toast);
		} else if (window.AlipayJSBridge) {
			webshowNativeToast(toast);
		} else {
			webshowNativeToast(toast);
		}
	}

	function createNewWebPage(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.createNewWebPage.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.createNewWebPage', obj, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.createNewWebPage', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webcreateNewWebPage(obj);
		} else if (window.AlipayJSBridge) {
			webcreateNewWebPage(obj);
		} else {
			webcreateNewWebPage(obj);
		}
	}

	function setCurPageId(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.setCurPageId.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.setCurPageId', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.setCurPageId', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webSetCurPageId(obj);
		} else if (window.AlipayJSBridge) {
			webSetCurPageId(obj);
		} else {
			webSetCurPageId(obj);
		}
	}
	var replaceBackBtnActionCallback = new function(pageId) {};

	function replaceBackBtnAction(callback) {
		replaceBackBtnActionCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.replaceBackBtnAction.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.replaceBackBtnAction', {}, function(
			responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.replaceBackBtnAction', {}, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {
			backBtnAction(callback);
		} else if (window.AlipayJSBridge) {
			backBtnAction(callback);
		} else {
			backBtnAction(callback);
		}
	}

	function onCustomBackAction(pageid) {
		replaceBackBtnActionCallback(pageid);
	}
	var fetchParamCallback = new function(obj) {};

	function fetchParam(callback) {
		fetchParamCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.fetchParam.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.fetchParam', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.fetchParam', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webfetchParam();
		} else if (window.AlipayJSBridge) {
			webfetchParam();
		} else {
			webfetchParam();
		}
	}

	function onFetchParamSuccessed(obj) {
		fetchParamCallback(obj);
	}

	function sendResultToOtherPage(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.sendResultToOtherPage.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.sendResultToOtherPage', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.sendResultToOtherPage', obj, function(
				responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}
	var receiverCallback = new function(obj) {};

	function registerReceiver(receiver) {
		receiverCallback = receiver;
	}

	function onReceiverResult(obj) {
		receiverCallback(obj);
	}

	function requestNet(serialNum, requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
		useAutoEncode) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestNet.postMessage({
				'serialNum': serialNum,
				'requestQueries': requestQueries,
				'requestUrl': requestUrl,
				'requestMethod': requestMethod,
				'requestBody': requestBody,
				'requestHeaders': requestHeaders
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestNet', {
				'serialNum': serialNum,
				'requestUrl': requestUrl,
				'requestMethod': requestMethod,
				'requestQueries': requestQueries,
				'requestHeaders': requestHeaders,
				'requestBody': requestBody,
				'useAutoEncode': useAutoEncode
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestNet', {
				'serialNum': serialNum,
				'requestUrl': requestUrl,
				'requestMethod': requestMethod,
				'requestQueries': requestQueries,
				'requestHeaders': requestHeaders,
				'requestBody': requestBody,
				'useAutoEncode': useAutoEncode
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webrequestNet(requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
				"            ");
		} else if (window.AlipayJSBridge) {
			webrequestNet(requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
				"               ");
		} else {
			webrequestNet(requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
				"pc      ");
		}
	}
	var callArray = [];

	function onRequestNetSuccessed(serialNum, statusObject, responseBody, responseHeaders) {
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var netback = callArray[x].callback;
			if (s == serialNum) {
				netback(statusObject, responseBody, responseHeaders);
				return;
			}
		}
	}

	function sendRequest(requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
		useAutoEncode) {
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray.push(call);
		if (useAutoEncode == undefined) {
			useAutoEncode = true;
		}
		requestNet(serialNum, requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback,
			useAutoEncode);
	}
	var titleBarFunctionCallback = new function(obj) {};

	function registerTitleBarFunctionCallback(callback) {
		titleBarFunctionCallback = callback;
	}

	function onTitleBarFunctionInvoked(obj) {
		titleBarFunctionCallback(obj);
	}

	function uuid() {
		var s = [];
		var hexDigits = "0123456789abcdef";
		for (var i = 0; i < 36; i++) {
			s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
		}
		s[14] = "4";
		s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);
		s[8] = s[13] = s[18] = s[23] = "-";
		var uuid = s.join("");
		return uuid;
	}

	function saveNativeStorage(key, val) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveNativeStorage.postMessage({
				'key': key,
				'val': val
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveNativeStorage', {
				'key': key,
				'val': val
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveNativeStorage', {
				'key': key,
				'val': val
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			websaveNativeStorage(key, val);
		} else if (window.AlipayJSBridge) {
			websaveNativeStorage(key, val);
		} else {
			websaveNativeStorage(key, val);
		}
	}

	function saveNativeStorageWithCallback(key, val, callback) {
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.saveNativeStorageWithCallback.postMessage({
				'key': key,
				'val': val,
				'serialNum': serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.saveNativeStorageWithCallback', {
				'key': key,
				'val': val,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.saveNativeStorageWithCallback', {
				'key': key,
				'val': val,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			websaveNativeStorage(key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		} else if (window.AlipayJSBridge) {
			websaveNativeStorage(key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		} else {
			websaveNativeStorage(key, val);
			callback(JSON.stringify({
				'error': ''
			}));
		}
	}

	function onsaveNativeStorageWithCallback(par) {
		var serialNum = par.serialNum;
		var val = par.val;
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var callback = callArray[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	}

	function getNativeStorage(skey, invokeCallback) {
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = invokeCallback;
		callArray.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getNativeStorage.postMessage({
				'key': skey,
				'serialNum': serialNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getNativeStorage', {
				'key': skey,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getNativeStorage', {
				'key': skey,
				'serialNum': serialNum
			}, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webgetNativeStorage(skey, serialNum);
		} else if (window.AlipayJSBridge) {
			webgetNativeStorage(skey, serialNum);
		} else {
			webgetNativeStorage(skey, serialNum);
		}
	}

	function onGetNativeStorageSuccessed(par) {
		var val = par.val;
		var serialNum = par.serialNum;
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var callback = callArray[x].callback;
			if (s == serialNum) {
				if (callback) {
					callback(val);
				}
				return;
			}
		}
	};
	var pickPhotosCallback = new function(obj) {};

	function pickPhotos(maxNum, invokeCallback) {
		if (invokeCallback != null)
			pickPhotosCallback = invokeCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.pickPhotos.postMessage({
				'body': maxNum
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.pickPhotos', maxNum, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.pickPhotos', maxNum, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onPickPhotosSuccessed(callbackparam) {
		pickPhotosCallback(callbackparam);
	};

	function backToPage(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.backToPage.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.backToPage', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.backToPage', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {
			webBackToPageWechart(obj);
		} else if (window.AlipayJSBridge) {
			webBackToPageAlipay(obj);
		} else {
			webBackToPage(obj);
		}
	}

	function openInBrowser(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.openInBrowser.postMessage({
				'body': obj
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.openInBrowser', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.openInBrowser', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}
	var buildTitleButtonGroupCallback = new function(obj) {};

	function buildTitleButtonGroup(array, invokeCallback) {
		if (invokeCallback != null)
			buildTitleButtonGroupCallback = invokeCallback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.buildTitleButtonGroup.postMessage({
				'body': array
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.buildTitleButtonGroup', array, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.buildTitleButtonGroup', array, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onBuildTitleButtonGroupSuccessed(callbackparam) {
		buildTitleButtonGroupCallback(callbackparam);
	};

	function registerBroadcast(feature, callback) {
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray.push(call);
		var realCall = {};
		realCall.feature = feature;
		realCall.serialNum = serialNum;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.registerBroadcast.postMessage({
				'body': realCall
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.registerBroadcast', realCall, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.registerBroadcast', realCall, function(
			responseData) {});
		} else if (window.WeixinJSBridge) {
			registerBroadcastPWA(feature, serialNum, callback)
		} else if (window.AlipayJSBridge) {
			registerBroadcastPWA(feature, serialNum, callback)
		} else {
			registerBroadcastPWA(feature, serialNum, callback)
		}
	}

	function sendBroadcast(feature, obj) {
		var realCall = {};
		realCall.feature = feature;
		realCall.obj = obj;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.sendBroadcast.postMessage({
				'body': realCall
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.sendBroadcast', realCall, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.sendBroadcast', realCall, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onBroadcastInvoked(serialNum, obj) {
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var back = callArray[x].callback;
			if (s == serialNum) {
				back(obj);
				return;
			}
		}
	}

	function requestKeepScreen(isKeepScreenOn) {
		var obj = {};
		obj.isKeepScreenOn = isKeepScreenOn;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.requestKeepScreen.postMessage(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.requestKeepScreen', obj, function(
				responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.requestKeepScreen', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}
	var getStackCallback = new function(res) {};

	function getStack(callback) {
		getStackCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getStack.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getStack', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getStack', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onGetStackSuccessed(res) {
		getStackCallback(res);
	}
	var getAppInfoCallback = new function(res) {};

	function getAppInfo(callback) {
		getAppInfoCallback = callback;
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.getAppInfo.postMessage(1);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.getAppInfo', {}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.getAppInfo', {}, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}

	function onGetAppInfoCallbackSuccessed(res) {
		getAppInfoCallback(res);
	}
	var rightNameClickCallback = function() {};

	function registerRightNameClick(callback) {
		rightNameClickCallback = callback;
	}

	function onRightNameClick() {
		rightNameClickCallback();
	}

	function onUploadFileNetSuccessed(serialNum, statusObject, responseBody, responseHeaders) {
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var netback = callArray[x].callback;
			if (s == serialNum) {
				netback(statusObject, responseBody, responseHeaders);
				return;
			}
		}
	}

	function uploadFile(obj, callback) {
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.uploadFile.postMessage({
				'serialNum': serialNum,
				'requestUrl': obj.requestUrl,
				'formID': obj.formID,
				'name': obj.name,
				'formData': obj.formData,
				'fileName': obj.fileName,
				'requestHeaders': obj.requestHeaders
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.uploadFile', {
				'serialNum': serialNum,
				'requestUrl': obj.requestUrl,
				'formID': obj.formID,
				'name': obj.name,
				'formData': obj.formData,
				'fileName': obj.fileName,
				'requestHeaders': obj.requestHeaders
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.uploadFile', {
				'serialNum': serialNum,
				'requestUrl': obj.requestUrl,
				'formID': obj.formID,
				'name': obj.name,
				'formData': obj.formData,
				'fileName': obj.fileName,
				'requestHeaders': obj.requestHeaders
			}, function(responseData) {});
		} else {}
	}

	function onDownloadFileNetSuccessed(serialNum, statusObject, vid) {
		for (x in callArray) {
			var s = callArray[x].serialNum;
			var netback = callArray[x].callback;
			if (s == serialNum) {
				netback(statusObject, vid);
				return;
			}
		}
	}

	function downloadFile(obj, callback) {
		var requestUrl = obj.url;
		var requestHeaders = obj.headers;
		var serialNum = uuid();
		var call = {};
		call.serialNum = serialNum;
		call.callback = callback;
		callArray.push(call);
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.downloadFile.postMessage({
				'serialNum': serialNum,
				'requestUrl': requestUrl,
				'requestHeaders': requestHeaders
			});
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.downloadFile', {
				'serialNum': serialNum,
				'requestUrl': requestUrl,
				'requestHeaders': requestHeaders
			}, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.downloadFile', {
				'serialNum': serialNum,
				'requestUrl': requestUrl,
				'requestHeaders': requestHeaders
			}, function(responseData) {});
		} else {}
	}
	var blockScreenshotCallback = function() {};

	function registerBlockScreenshot(callback) {
		blockScreenshotCallback = callback;
	}

	function onBlockScreenshotInvoked() {
		blockScreenshotCallback();
	}

	function sendSMS(obj) {
		if (window.iosdkqgqc) {
			window.webkit.messageHandlers.showToast.sendSMS(obj);
		} else if (window.WebViewJ2CJavascriptBridge) {
			window.WebViewJ2CJavascriptBridge.callHandler('Native.sendSMS', obj, function(responseData) {});
		} else if (window.WebViewJavascriptBridge && !window.AlipayJSBridge) {
			window.WebViewJavascriptBridge.callHandler('Native.sendSMS', obj, function(responseData) {});
		} else if (window.WeixinJSBridge) {} else if (window.AlipayJSBridge) {} else {}
	}
	window['J2C']['registerJ2CReadyCallback'] = registerJ2CReadyCallback;
	window['J2C']['replaceBackBtnAction'] = replaceBackBtnAction;
	window['J2C']['onCustomBackAction'] = onCustomBackAction;
	window['J2C']['createNewWebPage'] = createNewWebPage;
	window['J2C']['setCurPageId'] = setCurPageId;
	window['J2C']['fetchParam'] = fetchParam;
	window['J2C']['onFetchParamSuccessed'] = onFetchParamSuccessed;
	window['J2C']['registerReceiver'] = registerReceiver;
	window['J2C']['onReceiverResult'] = onReceiverResult;
	window['J2C']['sendResultToOtherPage'] = sendResultToOtherPage;
	window['J2C']['sendRequest'] = sendRequest;
	window['J2C']['onRequestNetSuccessed'] = onRequestNetSuccessed;
	window['J2C']['registerTitleBarFunctionCallback'] = registerTitleBarFunctionCallback;
	window['J2C']['onTitleBarFunctionInvoked'] = onTitleBarFunctionInvoked;
	window['J2C']['showNativeToast'] = showNativeToast;
	window['J2C']['saveNativeStorage'] = saveNativeStorage;
	window['J2C']['getNativeStorage'] = getNativeStorage;
	window['J2C']['onGetNativeStorageSuccessed'] = onGetNativeStorageSuccessed;
	window['J2C']['pickPhotos'] = pickPhotos;
	window['J2C']['onPickPhotosSuccessed'] = onPickPhotosSuccessed;
	window['J2C']['backToPage'] = backToPage;
	window['J2C']['openInBrowser'] = openInBrowser;
	window['J2C']['buildTitleButtonGroup'] = buildTitleButtonGroup;
	window['J2C']['onBuildTitleButtonGroupSuccessed'] = onBuildTitleButtonGroupSuccessed;
	window['J2C']['registerBroadcast'] = registerBroadcast;
	window['J2C']['onBroadcastInvoked'] = onBroadcastInvoked;
	window['J2C']['sendBroadcast'] = sendBroadcast;
	window['J2C']['requestKeepScreen'] = requestKeepScreen;
	window['J2C']['getStack'] = getStack;
	window['J2C']['onGetStackSuccessed'] = onGetStackSuccessed;
	window['J2C']['getAppInfo'] = getAppInfo;
	window['J2C']['onGetAppInfoCallbackSuccessed'] = onGetAppInfoCallbackSuccessed;
	window['J2C']['registerRightNameClick'] = registerRightNameClick;
	window['J2C']['onRightNameClick'] = onRightNameClick;
	window['J2C']['uploadFile'] = uploadFile;
	window['J2C']['onUploadFileNetSuccessed'] = onUploadFileNetSuccessed;
	window['J2C']['downloadFile'] = downloadFile;
	window['J2C']['onDownloadFileNetSuccessed'] = onDownloadFileNetSuccessed;
	window['J2C']['saveNativeStorageWithCallback'] = saveNativeStorageWithCallback;
	window['J2C']['onsaveNativeStorageWithCallback'] = onsaveNativeStorageWithCallback;
	window['J2C']['registerBlockScreenshot'] = registerBlockScreenshot;
	window['J2C']['onBlockScreenshotInvoked'] = onBlockScreenshotInvoked;
	window['J2C']['sendSMS'] = sendSMS;
})();
! function(e, n) {
	"function" == typeof define && (define.amd || define.cmd) ? define(function() {
		return n(e)
	}) : n(e, !0)
}(this, function(e, n) {
	function i(n, i, t) {
		e.WeixinJSBridge ? WeixinJSBridge.invoke(n, o(i), function(e) {
			c(n, e, t)
		}) : u(n, t)
	}

	function t(n, i, t) {
		e.WeixinJSBridge ? WeixinJSBridge.on(n, function(e) {
			t && t.trigger && t.trigger(e), c(n, e, i)
		}) : t ? u(n, t) : u(n, i)
	}

	function o(e) {
		return e = e || {}, e.appId = C.appId, e.verifyAppId = C.appId, e.verifySignType = "sha1", e
			.verifyTimestamp = C.timestamp + "", e.verifyNonceStr = C.nonceStr, e.verifySignature = C.signature, e
	}

	function r(e) {
		return {
			timeStamp: e.timestamp + "",
			nonceStr: e.nonceStr,
			package: e.package,
			paySign: e.paySign,
			signType: e.signType || "SHA1"
		}
	}

	function a(e) {
		return e.postalCode = e.addressPostalCode, delete e.addressPostalCode, e.provinceName = e
			.proviceFirstStageName, delete e.proviceFirstStageName, e.cityName = e.addressCitySecondStageName,
			delete e.addressCitySecondStageName, e.countryName = e.addressCountiesThirdStageName, delete e
			.addressCountiesThirdStageName, e.detailInfo = e.addressDetailInfo, delete e.addressDetailInfo, e
	}

	function c(e, n, i) {
		"openEnterpriseChat" == e && (n.errCode = n.err_code), delete n.err_code, delete n.err_desc, delete n
			.err_detail;
		var t = n.errMsg;
		t || (t = n.err_msg, delete n.err_msg, t = s(e, t), n.errMsg = t), (i = i || {})._complete && (i._complete(
			n), delete i._complete), t = n.errMsg || "", C.debug && !i.isInnerInvoke && alert(JSON.stringify(n));
		var o = t.indexOf(":");
		switch (t.substring(o + 1)) {
			case "ok":
				i.success && i.success(n);
				break;
			case "cancel":
				i.cancel && i.cancel(n);
				break;
			default:
				i.fail && i.fail(n)
		}
		i.complete && i.complete(n)
	}

	function s(e, n) {
		var i = e,
			t = v[i];
		t && (i = t);
		var o = "ok";
		if (n) {
			var r = n.indexOf(":");
			"confirm" == (o = n.substring(r + 1)) && (o = "ok"), "failed" == o && (o = "fail"), -1 != o.indexOf(
					"failed_") && (o = o.substring(7)), -1 != o.indexOf("fail_") && (o = o.substring(5)),
				"access denied" != (o = (o = o.replace(/_/g, " ")).toLowerCase()) && "no permission to execute" !=
				o || (o = "permission denied"), "config" == i && "function not exist" == o && (o = "ok"), "" == o &&
				(o = "fail")
		}
		return n = i + ":" + o
	}

	function d(e) {
		if (e) {
			for (var n = 0, i = e.length; n < i; ++n) {
				var t = e[n],
					o = h[t];
				o && (e[n] = o)
			}
			return e
		}
	}

	function u(e, n) {
		if (!(!C.debug || n && n.isInnerInvoke)) {
			var i = v[e];
			i && (e = i), n && n._complete && delete n._complete, console.log('"' + e + '",', n || "")
		}
	}

	function l(e) {
		if (!(k || w || C.debug || x < "6.0.2" || V.systemType < 0)) {
			var n = new Image;
			V.appId = C.appId, V.initTime = A.initEndTime - A.initStartTime, V.preVerifyTime = A.preVerifyEndTime -
				A.preVerifyStartTime, N.getNetworkType({
					isInnerInvoke: !0,
					success: function(e) {
						V.networkType = e.networkType;
						var i = "https://open.weixin.qq.com/sdk/report?v=" + V.version + "&o=" + V
							.isPreVerifyOk + "&s=" + V.systemType + "&c=" + V.clientVersion + "&a=" + V
							.appId + "&n=" + V.networkType + "&i=" + V.initTime + "&p=" + V.preVerifyTime +
							"&u=" + V.url;
						n.src = i
					}
				})
		}
	}

	function p() {
		return (new Date).getTime()
	}

	function f(n) {
		T && (e.WeixinJSBridge ? n() : S.addEventListener && S.addEventListener("WeixinJSBridgeReady", n, !1))
	}

	function m() {
		N.invoke || (N.invoke = function(n, i, t) {
			e.WeixinJSBridge && WeixinJSBridge.invoke(n, o(i), t)
		}, N.on = function(n, i) {
			e.WeixinJSBridge && WeixinJSBridge.on(n, i)
		})
	}

	function g(e) {
		if ("string" == typeof e && e.length > 0) {
			var n = e.split("?")[0],
				i = e.split("?")[1];
			return n += ".html", void 0 !== i ? n + "?" + i : n
		}
	}
	if (!e.jWeixin) {
		var h = {
				config: "preVerifyJSAPI",
				onMenuShareTimeline: "menu:share:timeline",
				onMenuShareAppMessage: "menu:share:appmessage",
				onMenuShareQQ: "menu:share:qq",
				onMenuShareWeibo: "menu:share:weiboApp",
				onMenuShareQZone: "menu:share:QZone",
				previewImage: "imagePreview",
				getLocation: "geoLocation",
				openProductSpecificView: "openProductViewWithPid",
				addCard: "batchAddCard",
				openCard: "batchViewCard",
				chooseWXPay: "getBrandWCPayRequest",
				openEnterpriseRedPacket: "getRecevieBizHongBaoRequest",
				startSearchBeacons: "startMonitoringBeacons",
				stopSearchBeacons: "stopMonitoringBeacons",
				onSearchBeacons: "onBeaconsInRange",
				consumeAndShareCard: "consumedShareCard",
				openAddress: "editAddress"
			},
			v = function() {
				var e = {};
				for (var n in h) e[h[n]] = n;
				return e
			}(),
			S = e.document,
			I = S.title,
			y = navigator.userAgent.toLowerCase(),
			_ = navigator.platform.toLowerCase(),
			k = !(!_.match("mac") && !_.match("win")),
			w = -1 != y.indexOf("wxdebugger"),
			T = -1 != y.indexOf("micromessenger"),
			M = -1 != y.indexOf("android"),
			P = -1 != y.indexOf("iphone") || -1 != y.indexOf("ipad"),
			x = function() {
				var e = y.match(/micromessenger\/(\d+\.\d+\.\d+)/) || y.match(/micromessenger\/(\d+\.\d+)/);
				return e ? e[1] : ""
			}(),
			A = {
				initStartTime: p(),
				initEndTime: 0,
				preVerifyStartTime: 0,
				preVerifyEndTime: 0
			},
			V = {
				version: 1,
				appId: "",
				initTime: 0,
				preVerifyTime: 0,
				networkType: "",
				isPreVerifyOk: 1,
				systemType: P ? 1 : M ? 2 : -1,
				clientVersion: x,
				url: encodeURIComponent(location.href)
			},
			C = {},
			L = {
				_completes: []
			},
			B = {
				state: 0,
				data: {}
			};
		f(function() {
			A.initEndTime = p()
		});
		var O = !1,
			E = [],
			N = {
				config: function(e) {
					C = e, u("config", e);
					var n = !1 !== C.check;
					f(function() {
						if (n) i(h.config, {
							verifyJsApiList: d(C.jsApiList)
						}, function() {
							L._complete = function(e) {
								A.preVerifyEndTime = p(), B.state = 1, B.data = e
							}, L.success = function(e) {
								V.isPreVerifyOk = 0
							}, L.fail = function(e) {
								L._fail ? L._fail(e) : B.state = -1
							};
							var e = L._completes;
							return e.push(function() {
								l()
							}), L.complete = function(n) {
								for (var i = 0, t = e.length; i < t; ++i) e[i]();
								L._completes = []
							}, L
						}()), A.preVerifyStartTime = p();
						else {
							B.state = 1;
							for (var e = L._completes, t = 0, o = e.length; t < o; ++t) e[t]();
							L._completes = []
						}
					}), m()
				},
				ready: function(e) {
					0 != B.state ? e() : (L._completes.push(e), !T && C.debug && e())
				},
				error: function(e) {
					x < "6.0.2" || (-1 == B.state ? e(B.data) : L._fail = e)
				},
				checkJsApi: function(e) {
					var n = function(e) {
						var n = e.checkResult;
						for (var i in n) {
							var t = v[i];
							t && (n[t] = n[i], delete n[i])
						}
						return e
					};
					i("checkJsApi", {
						jsApiList: d(e.jsApiList)
					}, (e._complete = function(e) {
						if (M) {
							var i = e.checkResult;
							i && (e.checkResult = JSON.parse(i))
						}
						e = n(e)
					}, e))
				},
				onMenuShareTimeline: function(e) {
					t(h.onMenuShareTimeline, {
						complete: function() {
							i("shareTimeline", {
								title: e.title || I,
								desc: e.title || I,
								img_url: e.imgUrl || "",
								link: e.link || location.href,
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}, e)
						}
					}, e)
				},
				onMenuShareAppMessage: function(e) {
					t(h.onMenuShareAppMessage, {
						complete: function(n) {
							"favorite" === n.scene ? i("sendAppMessage", {
								title: e.title || I,
								desc: e.desc || "",
								link: e.link || location.href,
								img_url: e.imgUrl || "",
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}) : i("sendAppMessage", {
								title: e.title || I,
								desc: e.desc || "",
								link: e.link || location.href,
								img_url: e.imgUrl || "",
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}, e)
						}
					}, e)
				},
				onMenuShareQQ: function(e) {
					t(h.onMenuShareQQ, {
						complete: function() {
							i("shareQQ", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				onMenuShareWeibo: function(e) {
					t(h.onMenuShareWeibo, {
						complete: function() {
							i("shareWeiboApp", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				onMenuShareQZone: function(e) {
					t(h.onMenuShareQZone, {
						complete: function() {
							i("shareQZone", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				updateTimelineShareData: function(e) {
					i("updateTimelineShareData", {
						title: e.title,
						link: e.link,
						imgUrl: e.imgUrl
					}, e)
				},
				updateAppMessageShareData: function(e) {
					i("updateAppMessageShareData", {
						title: e.title,
						desc: e.desc,
						link: e.link,
						imgUrl: e.imgUrl
					}, e)
				},
				startRecord: function(e) {
					i("startRecord", {}, e)
				},
				stopRecord: function(e) {
					i("stopRecord", {}, e)
				},
				onVoiceRecordEnd: function(e) {
					t("onVoiceRecordEnd", e)
				},
				playVoice: function(e) {
					i("playVoice", {
						localId: e.localId
					}, e)
				},
				pauseVoice: function(e) {
					i("pauseVoice", {
						localId: e.localId
					}, e)
				},
				stopVoice: function(e) {
					i("stopVoice", {
						localId: e.localId
					}, e)
				},
				onVoicePlayEnd: function(e) {
					t("onVoicePlayEnd", e)
				},
				uploadVoice: function(e) {
					i("uploadVoice", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				downloadVoice: function(e) {
					i("downloadVoice", {
						serverId: e.serverId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				translateVoice: function(e) {
					i("translateVoice", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				chooseImage: function(e) {
					i("chooseImage", {
						scene: "1|2",
						count: e.count || 9,
						sizeType: e.sizeType || ["original", "compressed"],
						sourceType: e.sourceType || ["album", "camera"]
					}, (e._complete = function(e) {
						if (M) {
							var n = e.localIds;
							try {
								n && (e.localIds = JSON.parse(n))
							} catch (e) {}
						}
					}, e))
				},
				getLocation: function(e) {},
				previewImage: function(e) {
					i(h.previewImage, {
						current: e.current,
						urls: e.urls
					}, e)
				},
				uploadImage: function(e) {
					i("uploadImage", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				downloadImage: function(e) {
					i("downloadImage", {
						serverId: e.serverId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				getLocalImgData: function(e) {
					!1 === O ? (O = !0, i("getLocalImgData", {
						localId: e.localId
					}, (e._complete = function(e) {
						if (O = !1, E.length > 0) {
							var n = E.shift();
							wx.getLocalImgData(n)
						}
					}, e))) : E.push(e)
				},
				getNetworkType: function(e) {
					var n = function(e) {
						var n = e.errMsg;
						e.errMsg = "getNetworkType:ok";
						var i = e.subtype;
						if (delete e.subtype, i) e.networkType = i;
						else {
							var t = n.indexOf(":"),
								o = n.substring(t + 1);
							switch (o) {
								case "wifi":
								case "edge":
								case "wwan":
									e.networkType = o;
									break;
								default:
									e.errMsg = "getNetworkType:fail"
							}
						}
						return e
					};
					i("getNetworkType", {}, (e._complete = function(e) {
						e = n(e)
					}, e))
				},
				openLocation: function(e) {
					i("openLocation", {
						latitude: e.latitude,
						longitude: e.longitude,
						name: e.name || "",
						address: e.address || "",
						scale: e.scale || 28,
						infoUrl: e.infoUrl || ""
					}, e)
				},
				getLocation: function(e) {
					e = e || {}, i(h.getLocation, {
						type: e.type || "wgs84"
					}, (e._complete = function(e) {
						delete e.type
					}, e))
				},
				hideOptionMenu: function(e) {
					i("hideOptionMenu", {}, e)
				},
				showOptionMenu: function(e) {
					i("showOptionMenu", {}, e)
				},
				closeWindow: function(e) {
					i("closeWindow", {}, e = e || {})
				},
				hideMenuItems: function(e) {
					i("hideMenuItems", {
						menuList: e.menuList
					}, e)
				},
				showMenuItems: function(e) {
					i("showMenuItems", {
						menuList: e.menuList
					}, e)
				},
				hideAllNonBaseMenuItem: function(e) {
					i("hideAllNonBaseMenuItem", {}, e)
				},
				showAllNonBaseMenuItem: function(e) {
					i("showAllNonBaseMenuItem", {}, e)
				},
				scanQRCode: function(e) {
					i("scanQRCode", {
						needResult: (e = e || {}).needResult || 0,
						scanType: e.scanType || ["qrCode", "barCode"]
					}, (e._complete = function(e) {
						if (P) {
							var n = e.resultStr;
							if (n) {
								var i = JSON.parse(n);
								e.resultStr = i && i.scan_code && i.scan_code.scan_result
							}
						}
					}, e))
				},
				openAddress: function(e) {
					i(h.openAddress, {}, (e._complete = function(e) {
						e = a(e)
					}, e))
				},
				openProductSpecificView: function(e) {
					i(h.openProductSpecificView, {
						pid: e.productId,
						view_type: e.viewType || 0,
						ext_info: e.extInfo
					}, e)
				},
				addCard: function(e) {
					for (var n = e.cardList, t = [], o = 0, r = n.length; o < r; ++o) {
						var a = n[o],
							c = {
								card_id: a.cardId,
								card_ext: a.cardExt
							};
						t.push(c)
					}
					i(h.addCard, {
						card_list: t
					}, (e._complete = function(e) {
						var n = e.card_list;
						if (n) {
							for (var i = 0, t = (n = JSON.parse(n)).length; i < t; ++i) {
								var o = n[i];
								o.cardId = o.card_id, o.cardExt = o.card_ext, o.isSuccess = !!o
									.is_succ, delete o.card_id, delete o.card_ext, delete o.is_succ
							}
							e.cardList = n, delete e.card_list
						}
					}, e))
				},
				chooseCard: function(e) {
					i("chooseCard", {
						app_id: C.appId,
						location_id: e.shopId || "",
						sign_type: e.signType || "SHA1",
						card_id: e.cardId || "",
						card_type: e.cardType || "",
						card_sign: e.cardSign,
						time_stamp: e.timestamp + "",
						nonce_str: e.nonceStr
					}, (e._complete = function(e) {
						e.cardList = e.choose_card_info, delete e.choose_card_info
					}, e))
				},
				openCard: function(e) {
					for (var n = e.cardList, t = [], o = 0, r = n.length; o < r; ++o) {
						var a = n[o],
							c = {
								card_id: a.cardId,
								code: a.code
							};
						t.push(c)
					}
					i(h.openCard, {
						card_list: t
					}, e)
				},
				consumeAndShareCard: function(e) {
					i(h.consumeAndShareCard, {
						consumedCardId: e.cardId,
						consumedCode: e.code
					}, e)
				},
				chooseWXPay: function(e) {
					i(h.chooseWXPay, r(e), e)
				},
				openEnterpriseRedPacket: function(e) {
					i(h.openEnterpriseRedPacket, r(e), e)
				},
				startSearchBeacons: function(e) {
					i(h.startSearchBeacons, {
						ticket: e.ticket
					}, e)
				},
				stopSearchBeacons: function(e) {
					i(h.stopSearchBeacons, {}, e)
				},
				onSearchBeacons: function(e) {
					t(h.onSearchBeacons, e)
				},
				openEnterpriseChat: function(e) {
					i("openEnterpriseChat", {
						useridlist: e.userIds,
						chatname: e.groupName
					}, e)
				},
				launchMiniProgram: function(e) {
					i("launchMiniProgram", {
						targetAppId: e.targetAppId,
						path: g(e.path),
						envVersion: e.envVersion
					}, e)
				},
				miniProgram: {
					navigateBack: function(e) {
						e = e || {}, f(function() {
							i("invokeMiniProgramAPI", {
								name: "navigateBack",
								arg: {
									delta: e.delta || 1
								}
							}, e)
						})
					},
					navigateTo: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "navigateTo",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					redirectTo: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "redirectTo",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					switchTab: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "switchTab",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					reLaunch: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "reLaunch",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					postMessage: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "postMessage",
								arg: e.data || {}
							}, e)
						})
					},
					getEnv: function(n) {
						f(function() {
							n({
								miniprogram: "miniprogram" === e.__wxjs_environment
							})
						})
					}
				}
			},
			b = 1,
			R = {};
		return S.addEventListener("error", function(e) {
			if (!M) {
				var n = e.target,
					i = n.tagName,
					t = n.src;
				if (("IMG" == i || "VIDEO" == i || "AUDIO" == i || "SOURCE" == i) && -1 != t.indexOf(
						"wxlocalresource://")) {
					e.preventDefault(), e.stopPropagation();
					var o = n["wx-id"];
					if (o || (o = b++, n["wx-id"] = o), R[o]) return;
					R[o] = !0, wx.ready(function() {
						wx.getLocalImgData({
							localId: t,
							success: function(e) {
								n.src = e.localData
							}
						})
					})
				}
			}
		}, !0), S.addEventListener("load", function(e) {
			if (!M) {
				var n = e.target,
					i = n.tagName;
				n.src;
				if ("IMG" == i || "VIDEO" == i || "AUDIO" == i || "SOURCE" == i) {
					var t = n["wx-id"];
					t && (R[t] = !1)
				}
			}
		}, !0), n && (e.wx = e.jWeixin = N), N
	}
});
! function(e, n) {
	"function" == typeof define && (define.amd || define.cmd) ? define(function() {
		return n(e)
	}) : n(e, !0)
}(this, function(e, n) {
	function i(n, i, t) {
		e.AlipayJSBridge ? AlipayJSBridge.invoke(n, o(i), function(e) {
			c(n, e, t)
		}) : u(n, t)
	}

	function t(n, i, t) {
		e.AlipayJSBridge ? AlipayJSBridge.on(n, function(e) {
			t && t.trigger && t.trigger(e), c(n, e, i)
		}) : t ? u(n, t) : u(n, i)
	}

	function o(e) {
		return e = e || {}, e.appId = C.appId, e.verifyAppId = C.appId, e.verifySignType = "sha1", e
			.verifyTimestamp = C.timestamp + "", e.verifyNonceStr = C.nonceStr, e.verifySignature = C.signature, e
	}

	function r(e) {
		return {
			timeStamp: e.timestamp + "",
			nonceStr: e.nonceStr,
			package: e.package,
			paySign: e.paySign,
			signType: e.signType || "SHA1"
		}
	}

	function a(e) {
		return e.postalCode = e.addressPostalCode, delete e.addressPostalCode, e.provinceName = e
			.proviceFirstStageName, delete e.proviceFirstStageName, e.cityName = e.addressCitySecondStageName,
			delete e.addressCitySecondStageName, e.countryName = e.addressCountiesThirdStageName, delete e
			.addressCountiesThirdStageName, e.detailInfo = e.addressDetailInfo, delete e.addressDetailInfo, e
	}

	function c(e, n, i) {
		"openEnterpriseChat" == e && (n.errCode = n.err_code), delete n.err_code, delete n.err_desc, delete n
			.err_detail;
		var t = n.errMsg;
		t || (t = n.err_msg, delete n.err_msg, t = s(e, t), n.errMsg = t), (i = i || {})._complete && (i._complete(
			n), delete i._complete), t = n.errMsg || "", C.debug && !i.isInnerInvoke && alert(JSON.stringify(n));
		var o = t.indexOf(":");
		switch (t.substring(o + 1)) {
			case "ok":
				i.success && i.success(n);
				break;
			case "cancel":
				i.cancel && i.cancel(n);
				break;
			default:
				i.fail && i.fail(n)
		}
		i.complete && i.complete(n)
	}

	function s(e, n) {
		var i = e,
			t = v[i];
		t && (i = t);
		var o = "ok";
		if (n) {
			var r = n.indexOf(":");
			"confirm" == (o = n.substring(r + 1)) && (o = "ok"), "failed" == o && (o = "fail"), -1 != o.indexOf(
					"failed_") && (o = o.substring(7)), -1 != o.indexOf("fail_") && (o = o.substring(5)),
				"access denied" != (o = (o = o.replace(/_/g, " ")).toLowerCase()) && "no permission to execute" !=
				o || (o = "permission denied"), "config" == i && "function not exist" == o && (o = "ok"), "" == o &&
				(o = "fail")
		}
		return n = i + ":" + o
	}

	function d(e) {
		if (e) {
			for (var n = 0, i = e.length; n < i; ++n) {
				var t = e[n],
					o = h[t];
				o && (e[n] = o)
			}
			return e
		}
	}

	function u(e, n) {
		if (!(!C.debug || n && n.isInnerInvoke)) {
			var i = v[e];
			i && (e = i), n && n._complete && delete n._complete, console.log('"' + e + '",', n || "")
		}
	}

	function l(e) {
		if (!(k || w || C.debug || x < "6.0.2" || V.systemType < 0)) {
			var n = new Image;
			V.appId = C.appId, V.initTime = A.initEndTime - A.initStartTime, V.preVerifyTime = A.preVerifyEndTime -
				A.preVerifyStartTime, N.getNetworkType({
					isInnerInvoke: !0,
					success: function(e) {
						V.networkType = e.networkType;
						var i = "https://open.weixin.qq.com/sdk/report?v=" + V.version + "&o=" + V
							.isPreVerifyOk + "&s=" + V.systemType + "&c=" + V.clientVersion + "&a=" + V
							.appId + "&n=" + V.networkType + "&i=" + V.initTime + "&p=" + V.preVerifyTime +
							"&u=" + V.url;
						n.src = i
					}
				})
		}
	}

	function p() {
		return (new Date).getTime()
	}

	function f(n) {
		T && (e.AlipayJSBridge ? n() : S.addEventListener && S.addEventListener("AlipayJSBridgeReady", n, !1))
	}

	function m() {
		N.invoke || (N.invoke = function(n, i, t) {
			e.AlipayJSBridge && AlipayJSBridge.invoke(n, o(i), t)
		}, N.on = function(n, i) {
			e.AlipayJSBridge && AlipayJSBridge.on(n, i)
		})
	}

	function g(e) {
		if ("string" == typeof e && e.length > 0) {
			var n = e.split("?")[0],
				i = e.split("?")[1];
			return n += ".html", void 0 !== i ? n + "?" + i : n
		}
	}
	if (!e.jWeixin) {
		var h = {
				config: "preVerifyJSAPI",
				onMenuShareTimeline: "menu:share:timeline",
				onMenuShareAppMessage: "menu:share:appmessage",
				onMenuShareQQ: "menu:share:qq",
				onMenuShareWeibo: "menu:share:weiboApp",
				onMenuShareQZone: "menu:share:QZone",
				previewImage: "imagePreview",
				getLocation: "geoLocation",
				openProductSpecificView: "openProductViewWithPid",
				addCard: "batchAddCard",
				openCard: "batchViewCard",
				chooseWXPay: "getBrandWCPayRequest",
				openEnterpriseRedPacket: "getRecevieBizHongBaoRequest",
				startSearchBeacons: "startMonitoringBeacons",
				stopSearchBeacons: "stopMonitoringBeacons",
				onSearchBeacons: "onBeaconsInRange",
				consumeAndShareCard: "consumedShareCard",
				openAddress: "editAddress"
			},
			v = function() {
				var e = {};
				for (var n in h) e[h[n]] = n;
				return e
			}(),
			S = e.document,
			I = S.title,
			y = navigator.userAgent.toLowerCase(),
			_ = navigator.platform.toLowerCase(),
			k = !(!_.match("mac") && !_.match("win")),
			w = -1 != y.indexOf("wxdebugger"),
			T = -1 != y.indexOf("micromessenger"),
			M = -1 != y.indexOf("android"),
			P = -1 != y.indexOf("iphone") || -1 != y.indexOf("ipad"),
			x = function() {
				var e = y.match(/micromessenger\/(\d+\.\d+\.\d+)/) || y.match(/micromessenger\/(\d+\.\d+)/);
				return e ? e[1] : ""
			}(),
			A = {
				initStartTime: p(),
				initEndTime: 0,
				preVerifyStartTime: 0,
				preVerifyEndTime: 0
			},
			V = {
				version: 1,
				appId: "",
				initTime: 0,
				preVerifyTime: 0,
				networkType: "",
				isPreVerifyOk: 1,
				systemType: P ? 1 : M ? 2 : -1,
				clientVersion: x,
				url: encodeURIComponent(location.href)
			},
			C = {},
			L = {
				_completes: []
			},
			B = {
				state: 0,
				data: {}
			};
		f(function() {
			A.initEndTime = p()
		});
		var O = !1,
			E = [],
			N = {
				config: function(e) {
					C = e, u("config", e);
					var n = !1 !== C.check;
					f(function() {
						if (n) i(h.config, {
							verifyJsApiList: d(C.jsApiList)
						}, function() {
							L._complete = function(e) {
								A.preVerifyEndTime = p(), B.state = 1, B.data = e
							}, L.success = function(e) {
								V.isPreVerifyOk = 0
							}, L.fail = function(e) {
								L._fail ? L._fail(e) : B.state = -1
							};
							var e = L._completes;
							return e.push(function() {
								l()
							}), L.complete = function(n) {
								for (var i = 0, t = e.length; i < t; ++i) e[i]();
								L._completes = []
							}, L
						}()), A.preVerifyStartTime = p();
						else {
							B.state = 1;
							for (var e = L._completes, t = 0, o = e.length; t < o; ++t) e[t]();
							L._completes = []
						}
					}), m()
				},
				ready: function(e) {
					0 != B.state ? e() : (L._completes.push(e), !T && C.debug && e())
				},
				error: function(e) {
					x < "6.0.2" || (-1 == B.state ? e(B.data) : L._fail = e)
				},
				checkJsApi: function(e) {
					var n = function(e) {
						var n = e.checkResult;
						for (var i in n) {
							var t = v[i];
							t && (n[t] = n[i], delete n[i])
						}
						return e
					};
					i("checkJsApi", {
						jsApiList: d(e.jsApiList)
					}, (e._complete = function(e) {
						if (M) {
							var i = e.checkResult;
							i && (e.checkResult = JSON.parse(i))
						}
						e = n(e)
					}, e))
				},
				onMenuShareTimeline: function(e) {
					t(h.onMenuShareTimeline, {
						complete: function() {
							i("shareTimeline", {
								title: e.title || I,
								desc: e.title || I,
								img_url: e.imgUrl || "",
								link: e.link || location.href,
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}, e)
						}
					}, e)
				},
				onMenuShareAppMessage: function(e) {
					t(h.onMenuShareAppMessage, {
						complete: function(n) {
							"favorite" === n.scene ? i("sendAppMessage", {
								title: e.title || I,
								desc: e.desc || "",
								link: e.link || location.href,
								img_url: e.imgUrl || "",
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}) : i("sendAppMessage", {
								title: e.title || I,
								desc: e.desc || "",
								link: e.link || location.href,
								img_url: e.imgUrl || "",
								type: e.type || "link",
								data_url: e.dataUrl || ""
							}, e)
						}
					}, e)
				},
				onMenuShareQQ: function(e) {
					t(h.onMenuShareQQ, {
						complete: function() {
							i("shareQQ", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				onMenuShareWeibo: function(e) {
					t(h.onMenuShareWeibo, {
						complete: function() {
							i("shareWeiboApp", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				onMenuShareQZone: function(e) {
					t(h.onMenuShareQZone, {
						complete: function() {
							i("shareQZone", {
								title: e.title || I,
								desc: e.desc || "",
								img_url: e.imgUrl || "",
								link: e.link || location.href
							}, e)
						}
					}, e)
				},
				updateTimelineShareData: function(e) {
					i("updateTimelineShareData", {
						title: e.title,
						link: e.link,
						imgUrl: e.imgUrl
					}, e)
				},
				updateAppMessageShareData: function(e) {
					i("updateAppMessageShareData", {
						title: e.title,
						desc: e.desc,
						link: e.link,
						imgUrl: e.imgUrl
					}, e)
				},
				startRecord: function(e) {
					i("startRecord", {}, e)
				},
				stopRecord: function(e) {
					i("stopRecord", {}, e)
				},
				onVoiceRecordEnd: function(e) {
					t("onVoiceRecordEnd", e)
				},
				playVoice: function(e) {
					i("playVoice", {
						localId: e.localId
					}, e)
				},
				pauseVoice: function(e) {
					i("pauseVoice", {
						localId: e.localId
					}, e)
				},
				stopVoice: function(e) {
					i("stopVoice", {
						localId: e.localId
					}, e)
				},
				onVoicePlayEnd: function(e) {
					t("onVoicePlayEnd", e)
				},
				uploadVoice: function(e) {
					i("uploadVoice", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				downloadVoice: function(e) {
					i("downloadVoice", {
						serverId: e.serverId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				translateVoice: function(e) {
					i("translateVoice", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				chooseImage: function(e) {
					i("chooseImage", {
						scene: "1|2",
						count: e.count || 9,
						sizeType: e.sizeType || ["original", "compressed"],
						sourceType: e.sourceType || ["album", "camera"]
					}, (e._complete = function(e) {
						if (M) {
							var n = e.localIds;
							try {
								n && (e.localIds = JSON.parse(n))
							} catch (e) {}
						}
					}, e))
				},
				getLocation: function(e) {},
				previewImage: function(e) {
					i(h.previewImage, {
						current: e.current,
						urls: e.urls
					}, e)
				},
				uploadImage: function(e) {
					i("uploadImage", {
						localId: e.localId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				downloadImage: function(e) {
					i("downloadImage", {
						serverId: e.serverId,
						isShowProgressTips: 0 == e.isShowProgressTips ? 0 : 1
					}, e)
				},
				getLocalImgData: function(e) {
					!1 === O ? (O = !0, i("getLocalImgData", {
						localId: e.localId
					}, (e._complete = function(e) {
						if (O = !1, E.length > 0) {
							var n = E.shift();
							wx.getLocalImgData(n)
						}
					}, e))) : E.push(e)
				},
				getNetworkType: function(e) {
					var n = function(e) {
						var n = e.errMsg;
						e.errMsg = "getNetworkType:ok";
						var i = e.subtype;
						if (delete e.subtype, i) e.networkType = i;
						else {
							var t = n.indexOf(":"),
								o = n.substring(t + 1);
							switch (o) {
								case "wifi":
								case "edge":
								case "wwan":
									e.networkType = o;
									break;
								default:
									e.errMsg = "getNetworkType:fail"
							}
						}
						return e
					};
					i("getNetworkType", {}, (e._complete = function(e) {
						e = n(e)
					}, e))
				},
				openLocation: function(e) {
					i("openLocation", {
						latitude: e.latitude,
						longitude: e.longitude,
						name: e.name || "",
						address: e.address || "",
						scale: e.scale || 28,
						infoUrl: e.infoUrl || ""
					}, e)
				},
				getLocation: function(e) {
					e = e || {}, i(h.getLocation, {
						type: e.type || "wgs84"
					}, (e._complete = function(e) {
						delete e.type
					}, e))
				},
				hideOptionMenu: function(e) {
					i("hideOptionMenu", {}, e)
				},
				showOptionMenu: function(e) {
					i("showOptionMenu", {}, e)
				},
				closeWindow: function(e) {
					i("closeWindow", {}, e = e || {})
				},
				hideMenuItems: function(e) {
					i("hideMenuItems", {
						menuList: e.menuList
					}, e)
				},
				showMenuItems: function(e) {
					i("showMenuItems", {
						menuList: e.menuList
					}, e)
				},
				hideAllNonBaseMenuItem: function(e) {
					i("hideAllNonBaseMenuItem", {}, e)
				},
				showAllNonBaseMenuItem: function(e) {
					i("showAllNonBaseMenuItem", {}, e)
				},
				scanQRCode: function(e) {
					i("scanQRCode", {
						needResult: (e = e || {}).needResult || 0,
						scanType: e.scanType || ["qrCode", "barCode"]
					}, (e._complete = function(e) {
						if (P) {
							var n = e.resultStr;
							if (n) {
								var i = JSON.parse(n);
								e.resultStr = i && i.scan_code && i.scan_code.scan_result
							}
						}
					}, e))
				},
				openAddress: function(e) {
					i(h.openAddress, {}, (e._complete = function(e) {
						e = a(e)
					}, e))
				},
				openProductSpecificView: function(e) {
					i(h.openProductSpecificView, {
						pid: e.productId,
						view_type: e.viewType || 0,
						ext_info: e.extInfo
					}, e)
				},
				addCard: function(e) {
					for (var n = e.cardList, t = [], o = 0, r = n.length; o < r; ++o) {
						var a = n[o],
							c = {
								card_id: a.cardId,
								card_ext: a.cardExt
							};
						t.push(c)
					}
					i(h.addCard, {
						card_list: t
					}, (e._complete = function(e) {
						var n = e.card_list;
						if (n) {
							for (var i = 0, t = (n = JSON.parse(n)).length; i < t; ++i) {
								var o = n[i];
								o.cardId = o.card_id, o.cardExt = o.card_ext, o.isSuccess = !!o
									.is_succ, delete o.card_id, delete o.card_ext, delete o.is_succ
							}
							e.cardList = n, delete e.card_list
						}
					}, e))
				},
				chooseCard: function(e) {
					i("chooseCard", {
						app_id: C.appId,
						location_id: e.shopId || "",
						sign_type: e.signType || "SHA1",
						card_id: e.cardId || "",
						card_type: e.cardType || "",
						card_sign: e.cardSign,
						time_stamp: e.timestamp + "",
						nonce_str: e.nonceStr
					}, (e._complete = function(e) {
						e.cardList = e.choose_card_info, delete e.choose_card_info
					}, e))
				},
				openCard: function(e) {
					for (var n = e.cardList, t = [], o = 0, r = n.length; o < r; ++o) {
						var a = n[o],
							c = {
								card_id: a.cardId,
								code: a.code
							};
						t.push(c)
					}
					i(h.openCard, {
						card_list: t
					}, e)
				},
				consumeAndShareCard: function(e) {
					i(h.consumeAndShareCard, {
						consumedCardId: e.cardId,
						consumedCode: e.code
					}, e)
				},
				chooseWXPay: function(e) {
					i(h.chooseWXPay, r(e), e)
				},
				openEnterpriseRedPacket: function(e) {
					i(h.openEnterpriseRedPacket, r(e), e)
				},
				startSearchBeacons: function(e) {
					i(h.startSearchBeacons, {
						ticket: e.ticket
					}, e)
				},
				stopSearchBeacons: function(e) {
					i(h.stopSearchBeacons, {}, e)
				},
				onSearchBeacons: function(e) {
					t(h.onSearchBeacons, e)
				},
				openEnterpriseChat: function(e) {
					i("openEnterpriseChat", {
						useridlist: e.userIds,
						chatname: e.groupName
					}, e)
				},
				launchMiniProgram: function(e) {
					i("launchMiniProgram", {
						targetAppId: e.targetAppId,
						path: g(e.path),
						envVersion: e.envVersion
					}, e)
				},
				miniProgram: {
					navigateBack: function(e) {
						e = e || {}, f(function() {
							i("invokeMiniProgramAPI", {
								name: "navigateBack",
								arg: {
									delta: e.delta || 1
								}
							}, e)
						})
					},
					navigateTo: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "navigateTo",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					redirectTo: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "redirectTo",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					switchTab: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "switchTab",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					reLaunch: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "reLaunch",
								arg: {
									url: e.url
								}
							}, e)
						})
					},
					postMessage: function(e) {
						f(function() {
							i("invokeMiniProgramAPI", {
								name: "postMessage",
								arg: e.data || {}
							}, e)
						})
					},
					getEnv: function(n) {
						f(function() {
							n({
								miniprogram: "miniprogram" === e.__wxjs_environment
							})
						})
					}
				}
			},
			b = 1,
			R = {};
		return S.addEventListener("error", function(e) {
			if (!M) {
				var n = e.target,
					i = n.tagName,
					t = n.src;
				if (("IMG" == i || "VIDEO" == i || "AUDIO" == i || "SOURCE" == i) && -1 != t.indexOf(
						"wxlocalresource://")) {
					e.preventDefault(), e.stopPropagation();
					var o = n["wx-id"];
					if (o || (o = b++, n["wx-id"] = o), R[o]) return;
					R[o] = !0, wx.ready(function() {
						wx.getLocalImgData({
							localId: t,
							success: function(e) {
								n.src = e.localData
							}
						})
					})
				}
			}
		}, !0), S.addEventListener("load", function(e) {
			if (!M) {
				var n = e.target,
					i = n.tagName;
				n.src;
				if ("IMG" == i || "VIDEO" == i || "AUDIO" == i || "SOURCE" == i) {
					var t = n["wx-id"];
					t && (R[t] = !1)
				}
			}
		}, !0), n && (e.wx = e.jWeixin = N), N
	}
});

function webBackToPageWechart(obj) {
	var ishas = false;
	if (localStorage.getItem("curPageList") == "" || localStorage.getItem("curPageList") == null) {
		var curPageList = [];
	} else {
		curPageList = JSON.parse(localStorage.getItem("curPageList"));
		for (var i = 0; i < curPageList.length; i++) {
			if (obj.toPageId == curPageList[0].pageId) {
				localStorage.removeItem("curPageList");
				location.href = curPageList[0].url;
				ishas = true;
				break;
			} else if ((obj.toPageId == curPageList[i].pageId) && (obj.toPageId != curPageList[0].pageId)) {
				location.href = curPageList[i].url;
				ishas = true;
				break;
			}
			if (obj.toPageId == "" || obj.toPageId == null) {
				ishas = true;
				history.go(-1);
				break;
			}
		}
	}
	if (!ishas) {
		WeixinJSBridge.call('closeWindow');
	}
}

function webshowNativeToast(msg, time) {
	if (document.getElementById("alertm")) {
		document.body.removeChild(document.getElementById("alertm"));
	}
	var adiv = document.createElement("div");
	adiv.setAttribute("id", "alertm");
	adiv.style.position = "fixed";
	adiv.style.bottom = "50px";
	adiv.style.left = "0";
	adiv.style.right = "0";
	adiv.style.textAlign = "center";
	adiv.style.zIndex = "99999";
	var aspan = document.createElement("span");
	adiv.appendChild(aspan);
	aspan.style.display = "inline-block";
	aspan.style.padding = "5px 45px";
	aspan.style.color = "#fff";
	aspan.style.fontSize = "14px";
	aspan.style.background = "rgba(33, 33, 33, .7)";
	aspan.style.borderRadius = "5px";
	aspan.innerText = msg;
	document.body.appendChild(adiv);
	if (time == null || time == "") {
		time = 1500;
	}
	setTimeout("document.body.removeChild(document.getElementById('alertm'))", time);
}

function webcreateNewWebPage(obj) {
	webSetCurPageId(obj);
	if (typeof obj.param == "string") {
		localStorage.setItem("webCreateNewPage", obj.param);
	} else if (typeof obj.param == "object") {
		localStorage.setItem("webCreateNewPage", JSON.stringify(obj.param));
	}
	location.href = obj.url;
}

function webfetchParam() {
	var data = localStorage.getItem("webCreateNewPage");
	if (data != null && data != "") {
		if (data.indexOf("{") != -1 || data.indexOf("[") != -1) {
			J2C.onFetchParamSuccessed(JSON.parse(data));
		} else {
			J2C.onFetchParamSuccessed(data);
		}
	} else {
		J2C.onFetchParamSuccessed({});
	}
}

function httpreq(url, type, data, headers, isAsync, time, success) {
	var request = new XMLHttpRequest();
	var timeout = false;
	var timer = setTimeout(function() {
		timeout = true;
		request.abort();
	}, time);
	request.open(type, url, isAsync);
	Object.getOwnPropertyNames(headers).forEach(function(key) {
		request.setRequestHeader(key, headers[key]);
	})
	request.onreadystatechange = function() {
		if (request.readyState !== 4) return;
		if (timeout) return;
		clearTimeout(timer);
		var headers = request.getAllResponseHeaders();
		var responseobj = {
			"status": request.status,
			"data": request.response,
			"headers": headers
		}
		success(responseobj);
	};
	request.send(['put', 'post'].indexOf(type.toLocaleLowerCase()) === -1 ? null : JSON.stringify(data));
}

function http_builder_url(url, data) {
	if (typeof(url) == 'undefined' || url == null || url == '') {
		return '';
	}
	if (typeof(data) == 'undefined' || data == null || typeof(data) != 'object') {
		return '';
	}
	url += (url.indexOf("?") != -1) ? "" : "?";
	for (var k in data) {
		url += ((url.indexOf("=") != -1) ? "&" : "") + k + "=" + encodeURI(data[k]);
		console.log(url);
	}
	return url;
}

function webrequestNet(requestUrl, requestMethod, requestQueries, requestBody, requestHeaders, callback, type) {
	var url = http_builder_url(requestUrl, requestQueries);
	httpreq(url, requestMethod, requestBody, requestHeaders, true, 6000, function(response) {
		console.log('suc', response);
		var data = response.data;
		try {
			var tem = JSON.parse(data);
			data = tem;
		} catch (e) {}
		callback({
			"code": response.status
		}, data, response.headers);
	})
}

function websaveNativeStorage(key, val) {
	localStorage.setItem(key, val);
}

function webgetNativeStorage(skey, serialNum, invokeCallback) {
	var obj = {
		val: localStorage.getItem(skey),
		serialNum: serialNum
	};
	if (obj == null || typeof obj == 'undefined') {
		obj = {};
	}
	J2C.onGetNativeStorageSuccessed(obj);
}

function webSetCurPageId(obj) {
	if (localStorage.getItem("curPageList") == "" || localStorage.getItem("curPageList") == null) {
		var curPageList = [];
	} else {
		curPageList = JSON.parse(localStorage.getItem("curPageList"));
	}
	curPageList.push(obj);
	localStorage.setItem("curPageList", JSON.stringify(curPageList));
}

function backBtnAction(callback) {
	pushHistory();
	var newCallback = genNewCallback(callback);
	window.addEventListener("popstate", newCallback, false);

	function genNewCallback(callback) {
		return function(event) {
			callback(event);
			pushHistory();
		}
	}

	function pushHistory() {
		var state = {
			title: "title",
			url: "#"
		};
		window.history.pushState(state, "title", "#");
	}
}

function webBackToPage(obj) {
	var ishas = false;
	if (localStorage.getItem("curPageList") == "" || localStorage.getItem("curPageList") == null) {
		var curPageList = [];
	} else {
		curPageList = JSON.parse(localStorage.getItem("curPageList"));
		for (var i = 0; i < curPageList.length; i++) {
			if (obj.toPageId == curPageList[0].pageId) {
				localStorage.removeItem("curPageList");
				location.href = curPageList[0].url;
				ishas = true;
				break;
			} else if ((obj.toPageId == curPageList[i].pageId) && (obj.toPageId != curPageList[0].pageId)) {
				location.href = curPageList[i].url;
				ishas = true;
				break;
			}
			if (obj.toPageId == "" || obj.toPageId == null) {
				ishas = true;
				history.go(-1);
				break;
			}
		}
	}
	if (!ishas) {
		history.go(-1);
	}
}

function getViewPdf(paramJsonObj, browser) {
	console.log(browser)
	var obj = {};
	obj.pageId = "pdf";
	obj.url = global_config.ahrefUrl + "pdfView/pdf.html";
	if (browser == "PC") {
		paramJsonObj.url = paramJsonObj.url + paramJsonObj.weixin || "";
	} else if (browser == "WECHAT") {
		paramJsonObj.url = paramJsonObj.url + paramJsonObj.weixin || "";
	}
	obj.param = paramJsonObj;
	console.log(obj)
	J2C.createNewWebPage(obj);
}

function registerBroadcastPWA(feature, serialNum) {
	if (localStorage.getItem("curPageList") == "" || localStorage.getItem("curPageList") == null) {
		var curPageList = [];
		var vobj = {
			"pageId": "root",
			"url": window.location.href
		}
		webSetCurPageId(vobj);
	}
	curPageList = JSON.parse(localStorage.getItem("curPageList"));
	for (curpage in curPageList) {
		if (curPageList[curpage].url == window.location.href) {
			if (isEmpty(curPageList[curpage][feature])) {
				J2C.onBroadcastInvoked(serialNum, curPageList[curpage][feature]);
				break;
			}
			curPageList[curpage][feature] = feature;
			localStorage.setItem("curPageList", JSON.stringify(curPageList));
		}
	}
}

function sendBroadcastPWA(feature, obj) {
	curPageList = JSON.parse(localStorage.getItem("curPageList"));
	for (curpage in curPageList) {
		if (isEmpty(curPageList[curpage][feature])) {
			for (key in curPageList[curpage]) {
				console.log(key)
				if (key == feature) {
					console.log("            ")
					curPageList[curpage][feature] = obj;
					localStorage.setItem("curPageList", JSON.stringify(curPageList));
				}
			}
		}
	}
}

function getLogInHistoryPWA(serialNum) {
	var logHisLists = [];
	var accountIdList = isEmpty(localStorage.getItem("accountIdList")) ? JSON.parse(localStorage.getItem(
		"accountIdList")) : [];
	if (accountIdList.length > 0) {
		for (i in accountIdList) {
			if (accountIdList[i] != "PublicAccount") {
				var l = {
					"userName": accountIdList[i]
				};
				logHisLists.push(l);
			}
		}
	}
	var loginH = {
		"serialNum": serialNum,
		"obj": JSON.stringify(logHisLists)
	};
	J2C.onGetLogInHistory(loginH);
}

function getLogInAccountIdPWA(serialNum) {
	var loginAc = [];
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	if (loginHistoryList.length > 0) {
		for (i in loginHistoryList) {
			loginAc.push(loginHistoryList[i].loginTrue ? true : false);
			if (loginHistoryList[i].loginTrue) {
				var obj = {
					"accountId": loginHistoryList[i].accountId,
					"serialNum": serialNum
				}
				J2C.ongetLogInAccountId(obj);
			}
		}
		if (loginAc.indexOf(true) < 0) {
			var obj = {
				"accountId": "PublicAccount",
				"serialNum": serialNum
			}
			J2C.ongetLogInAccountId(obj);
		}
	} else {
		var obj = {
			"accountId": "PublicAccount",
			"serialNum": serialNum
		}
		J2C.ongetLogInAccountId(obj);
	}
}

function chooseAccountPWA(accountId) {
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	if (loginHistoryList.length > 0) {
		for (i in loginHistoryList) {
			loginHistoryList[i].loginTrue = false;
			if (loginHistoryList[i].accountId == accountId) {
				loginHistoryList[i].loginTrue = true;
				var trueItem = loginHistoryList[i];
				var trueItem1 = loginHistoryList[i];
				spliceList(trueItem, loginHistoryList);
				loginHistoryList.splice(0, 0, trueItem1);
			} else if (accountId == "PublicAccount") {
				var obj = {
					"accountId": "PublicAccount",
					"loginTrue": true
				}
			}
		}
	}
	localStorage.setItem("loginHistoryList", JSON.stringify(loginHistoryList));
	sendBroadcastPWA("NSSUserAccountChangedMessage", {
		"param": accountId
	});
	console.log(loginHistoryList)
}

function logInOutPWA() {
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	console.log(loginHistoryList)
	chooseAccountPWA("PublicAccount");
	J2C.getLogInAccountId();
}

function saveAccountInfoPWA(accountId, token, refreshToken, userName) {
	var info = {
		"accountId": accountId,
		"token": token,
		"refreshToken": refreshToken,
		"userName": userName
	}
	saveUserInfoPWA(accountId, "accountInfo", JSON.stringify(info));
}

function saveUserInfoPWA(accountId, key, val) {
	var accountIdList = isEmpty(localStorage.getItem("accountIdList")) ? JSON.parse(localStorage.getItem(
		"accountIdList")) : [];
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	if (loginHistoryList.length > 0 && accountIdList.indexOf(accountId) >= 0) {
		for (i in loginHistoryList) {
			if (loginHistoryList[i].accountId == accountId) {
				loginHistoryList[i][key] = val;
				break;
			}
		}
	} else {
		var obj = {
			"accountId": accountId,
		}
		obj[key] = val;
		loginHistoryList.push(obj);
		accountIdList.push(accountId);
	}
	localStorage.setItem("loginHistoryList", JSON.stringify(loginHistoryList));
	localStorage.setItem("accountIdList", JSON.stringify(accountIdList));
}

function getAccountInfoPWA(accountId, serialNum) {
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	if (loginHistoryList.length > 0) {
		for (i in loginHistoryList) {
			if (loginHistoryList[i].accountId == accountId) {
				var obj = {
					"accountId": accountId,
					"userName": accountId,
					"serialNum": serialNum,
					"token": JSON.parse(loginHistoryList[i].accountInfo).token,
					"refreshToken": JSON.parse(loginHistoryList[i].accountInfo).refreshToken
				};
				J2C.onGetAccountInfo(obj);
				return;
			}
		}
	}
	J2C.onGetAccountInfo({});
}

function getUserInfoPWA(accountId, key, serialNum) {
	var loginHistoryList = isEmpty(localStorage.getItem("loginHistoryList")) ? JSON.parse(localStorage.getItem(
		"loginHistoryList")) : [];
	if (loginHistoryList.length > 0) {
		for (i in loginHistoryList) {
			if (loginHistoryList[i].accountId == accountId) {
				var obj = {
					"serialNum": serialNum,
					"val": loginHistoryList[i][key]
				};
				J2C.ongetUserInfo(obj);
			}
		}
	} else {
		var obj = {
			"serialNum": serialNum,
			"val": ""
		};
		J2C.ongetUserInfo(obj);
	}
}

function webBackToPageAlipay(obj) {
	var ishas = false;
	if (localStorage.getItem("curPageList") == "" || localStorage.getItem("curPageList") == null) {
		var curPageList = [];
	} else {
		curPageList = JSON.parse(localStorage.getItem("curPageList"));
		for (var i = 0; i < curPageList.length; i++) {
			if (obj.toPageId == curPageList[0].pageId) {
				localStorage.removeItem("curPageList");
				location.href = curPageList[0].url;
				ishas = true;
				break;
			} else if ((obj.toPageId == curPageList[i].pageId) && (obj.toPageId != curPageList[0].pageId)) {
				location.href = curPageList[i].url;
				ishas = true;
				break;
			}
			if (obj.toPageId == "" || obj.toPageId == null) {
				ishas = true;
				history.go(-1);
				break;
			}
		}
	}
	if (!ishas) {
		AlipayJSBridge.call('closeWebview')
	}
}
